export declare class Key {
    readonly pub: string;
    readonly sec: string;
    constructor(pub: string, sec: string);
    /*****************************
    *
    *      GENERAL CRYPTO
    *
    *****************************/
    readonly publicKey: string;
    readonly secretKey: string;
    private rawSec;
    json(): {
        pub: string;
        sec: string;
    };
    sign(msg: string): Promise<string>;
    signSync(msg: string): string;
}
export declare function randomKey(): Key;
export declare function KeyGen(pub: string, sec: string): Key;
/**
 * Verify a signature against data & public key.
 * Return true of false as callback argument.
 */
export declare function verify(rawMsg: string, rawSig: string, rawPub: string): any;
