"use strict";
// Source file from duniter: Crypto-currency software to manage libre currency such as Ğ1
// Copyright (C) 2018  Cedric Moreau <cem.moreau@gmail.com>
//
// This program is free software: you can redistribute it and/or modify
// it under the terms of the GNU Affero General Public License as published by
// the Free Software Foundation, either version 3 of the License, or
// (at your option) any later version.
//
// This program is distributed in the hope that it will be useful,
// but WITHOUT ANY WARRANTY; without even the implied warranty of
// MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
// GNU Affero General Public License for more details.
Object.defineProperty(exports, "__esModule", { value: true });
exports.decodeUTF8 = function (s) {
    let i, d = unescape(encodeURIComponent(s)), b = new Uint8Array(d.length);
    for (i = 0; i < d.length; i++)
        b[i] = d.charCodeAt(i);
    return b;
};
exports.encodeUTF8 = function (arr) {
    let i, s = [];
    for (i = 0; i < arr.length; i++)
        s.push(String.fromCharCode(arr[i]));
    return decodeURIComponent(escape(s.join('')));
};
exports.encodeBase64 = function (arr) {
    if (typeof btoa === 'undefined' || !window) {
        return (new Buffer(arr)).toString('base64');
    }
    else {
        let i, s = [], len = arr.length;
        for (i = 0; i < len; i++)
            s.push(String.fromCharCode(arr[i]));
        return btoa(s.join(''));
    }
};
exports.decodeBase64 = function (s) {
    if (typeof atob === 'undefined' || !window) {
        return new Uint8Array(Array.prototype.slice.call(new Buffer(s, 'base64'), 0));
    }
    else {
        let i, d = atob(s), b = new Uint8Array(d.length);
        for (i = 0; i < d.length; i++)
            b[i] = d.charCodeAt(i);
        return b;
    }
};
//# sourceMappingURL=nacl-util.js.map