"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
const querablePromise = require('querablep');
/**
 * Creates a new querable promise that can is manually triggered.
 * @returns {ManualPromise<T>}
 */
function newManualPromise() {
    let resolveCb = () => { };
    let rejectCb = () => { };
    const p = new Promise((res, rej) => {
        resolveCb = res;
        rejectCb = rej;
    });
    const q = querablePromise(p);
    q.resolve = resolveCb;
    q.reject = rejectCb;
    return q;
}
exports.newManualPromise = newManualPromise;
//# sourceMappingURL=manual-promise.js.map