"use strict";
// Source file from duniter: Crypto-currency software to manage libre currency such as Ğ1
// Copyright (C) 2018  Cedric Moreau <cem.moreau@gmail.com>
//
// This program is free software: you can redistribute it and/or modify
// it under the terms of the GNU Affero General Public License as published by
// the Free Software Foundation, either version 3 of the License, or
// (at your option) any later version.
//
// This program is distributed in the hope that it will be useful,
// but WITHOUT ANY WARRANTY; without even the implied warranty of
// MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
// GNU Affero General Public License for more details.
Object.defineProperty(exports, "__esModule", { value: true });
const block_1 = require("./block");
const certification_1 = require("./certification");
const identity_1 = require("./identity");
const membership_1 = require("./membership");
const peer_1 = require("./peer");
const revocation_1 = require("./revocation");
const transaction_1 = require("./transaction");
exports.parsers = {
    parseIdentity: new identity_1.IdentityParser(),
    parseCertification: new certification_1.CertificationParser(),
    parseRevocation: new revocation_1.RevocationParser(),
    parseTransaction: new transaction_1.TransactionParser(),
    parsePeer: new peer_1.PeerParser(),
    parseMembership: new membership_1.MembershipParser(),
    parseBlock: new block_1.BlockParser()
};
//# sourceMappingURL=index.js.map