import { AbstractCFS } from "./AbstractCFS";
import { ConfDTO } from "../../dto/ConfDTO";
import { FileSystem } from "../../system/directory";
import { ConfDAO } from "../indexDAL/abstract/ConfDAO";
export declare class ConfDAL extends AbstractCFS implements ConfDAO {
    private logger;
    constructor(rootPath: string, qioFS: FileSystem);
    init(): Promise<void>;
    close(): Promise<void>;
    getParameters(): Promise<{
        "currency": any;
        "c": number;
        "dt": number;
        "ud0": number;
        "sigPeriod": number;
        "sigStock": number;
        "sigWindow": number;
        "sigValidity": number;
        "sigQty": number;
        "sigReplay": number;
        "idtyWindow": number;
        "msWindow": number;
        "msPeriod": number;
        "xpercent": number;
        "msValidity": number;
        "stepMax": number;
        "medianTimeBlocks": number;
        "avgGenTime": number;
        "dtDiffEval": number;
        "percentRot": number;
        "udTime0": number;
        "udReevalTime0": number;
        "dtReeval": number;
        "switchOnHeadAdvance": number;
    }>;
    readRawConfFile(): Promise<string | null>;
    loadConf(): Promise<any>;
    saveConf(confToSave: ConfDTO): Promise<void>;
}
