import { DBBlock } from "../../../../db/DBBlock";
export interface ForksDAO {
    saveSideBlock(block: DBBlock): Promise<DBBlock>;
    setSideBlock(number: number, previousBlock: DBBlock | null): Promise<void>;
    getPotentialRoots(): Promise<DBBlock[]>;
    getNextForkBlocks(number: number, hash: string): Promise<DBBlock[]>;
    /**
     * Find any fork block whose number is between `numberStart` and `maxNumber`, both included, and whose medianTime is
     * >= `medianTimeStart`.
     * @param numberStart
     * @param medianTimeStart
     * @param maxNumber
     */
    getPotentialForkBlocks(numberStart: number, medianTimeStart: number, maxNumber: number): Promise<DBBlock[]>;
    removeForkBlock(number: number): Promise<void>;
    removeForkBlockAboveOrEqual(number: number): Promise<void>;
}
