import { DividendEntry, UDSource } from "../abstract/DividendDAO";
import { SimpleUdEntryForWallet, SindexEntry } from "../../../indexer";
export declare class DividendDaoHandler {
    static getNewDividendEntry(pub: string): DividendEntry;
    static produceDividend(r: DividendEntry, blockNumber: number, dividend: number, unitbase: number, dividends?: SimpleUdEntryForWallet[]): void;
    static consume(m: DividendEntry, dividendToConsume: SindexEntry): void;
    static udSources(member: DividendEntry): UDSource[];
    private static toUDSource;
    static getUDSourceByIdPosAmountBase(member: DividendEntry | null, identifier: string, pos: number, amount: number, base: number): {
        written_time: number;
        conditions: string;
        consumed: boolean;
        amount: number;
        base: number;
    }[];
    static getUDSource(member: DividendEntry | null, identifier: string, pos: number): {
        written_time: number;
        conditions: string;
        consumed: boolean;
        amount: number;
        base: number;
    } | null;
    static getWrittenOnUDs(m: DividendEntry, number: number, res: SimpleUdEntryForWallet[]): void;
    static removeDividendsProduced(m: DividendEntry, number: number, createdUDsDestroyedByRevert: SimpleUdEntryForWallet[]): void;
    static unconsumeDividends(m: DividendEntry, number: number, consumedUDsRecoveredByRevert: SimpleUdEntryForWallet[]): void;
    static trimConsumed(m: DividendEntry, belowNumber: number): boolean;
    static toDump(rows: DividendEntry[]): SindexEntry[];
}
