import { LevelUp } from 'levelup';
import { LevelDBTable } from "./LevelDBTable";
import { BIndexDAO } from "../abstract/BIndexDAO";
import { DBHead } from "../../../db/DBHead";
export declare class LevelDBBindex extends LevelDBTable<DBHead> implements BIndexDAO {
    constructor(getLevelDB: (dbName: string) => Promise<LevelUp>);
    /**
     * INSERT
     */
    insert(record: DBHead): Promise<void>;
    insertBatch(records: DBHead[]): Promise<void>;
    findRawWithOrder(criterion: {
        pub?: string;
    }, sort: (string | (string | boolean)[])[]): Promise<DBHead[]>;
    getWrittenOn(blockstamp: string): Promise<DBHead[]>;
    head(n: number): Promise<DBHead>;
    range(n: number, m: number): Promise<DBHead[]>;
    removeBlock(blockstamp: string): Promise<void>;
    tail(): Promise<DBHead>;
    trimBlocks(maxnumber: number): Promise<void>;
    private static trimKey;
}
