"use strict";
var __decorate = (this && this.__decorate) || function (decorators, target, key, desc) {
    var c = arguments.length, r = c < 3 ? target : desc === null ? desc = Object.getOwnPropertyDescriptor(target, key) : desc, d;
    if (typeof Reflect === "object" && typeof Reflect.decorate === "function") r = Reflect.decorate(decorators, target, key, desc);
    else for (var i = decorators.length - 1; i >= 0; i--) if (d = decorators[i]) r = (c < 3 ? d(r) : c > 3 ? d(target, key, r) : d(target, key)) || r;
    return c > 3 && r && Object.defineProperty(target, key, r), r;
};
Object.defineProperty(exports, "__esModule", { value: true });
const MonitorExecutionTime_1 = require("../../../debug/MonitorExecutionTime");
const LevelDBTable_1 = require("./LevelDBTable");
const underscore_1 = require("../../../common-libs/underscore");
class LevelDBBindex extends LevelDBTable_1.LevelDBTable {
    constructor(getLevelDB) {
        super('level_bindex', getLevelDB);
    }
    /**
     * INSERT
     */
    async insert(record) {
        await this.insertBatch([record]);
    }
    async insertBatch(records) {
        // Update the max headNumber
        await this.batchInsertWithKeyComputing(records, r => LevelDBBindex.trimKey(r.number));
    }
    findRawWithOrder(criterion, sort) {
        return this.findAllValues();
    }
    async getWrittenOn(blockstamp) {
        return [(await this.get(LevelDBBindex.trimKey(parseInt(blockstamp))))];
    }
    async head(n) {
        return (await this.findAllValues({
            limit: n,
            reverse: true
        }))[n - 1] || null;
    }
    async range(n, m) {
        const head = await this.head(1);
        if (!head) {
            return [];
        }
        const from = head.number - n + 2;
        const to = head.number - m;
        return this.findAllValues({
            gt: LevelDBBindex.trimKey(to),
            lt: LevelDBBindex.trimKey(from),
            reverse: true
        });
    }
    async removeBlock(blockstamp) {
        await this.del(LevelDBBindex.trimKey(parseInt(blockstamp)));
    }
    async tail() {
        return (await this.findAllValues({
            limit: 1
        }))[0] || null;
    }
    async trimBlocks(maxnumber) {
        const tail = await this.tail();
        if (!tail) {
            return;
        }
        const from = Math.max(tail.number, 0);
        await Promise.all(underscore_1.Underscore.range(from, maxnumber).map(async (k) => {
            await this.del(LevelDBBindex.trimKey(k));
        }));
    }
    static trimKey(number) {
        return String(number).padStart(10, '0');
    }
}
__decorate([
    MonitorExecutionTime_1.MonitorExecutionTime()
], LevelDBBindex.prototype, "insert", null);
__decorate([
    MonitorExecutionTime_1.MonitorExecutionTime()
], LevelDBBindex.prototype, "insertBatch", null);
exports.LevelDBBindex = LevelDBBindex;
//# sourceMappingURL=LevelDBBindex.js.map