import { DividendDAO, DividendEntry, UDSource } from "../abstract/DividendDAO";
import { IindexEntry, SimpleTxInput, SimpleUdEntryForWallet, SindexEntry } from "../../../indexer";
import { LevelUp } from 'levelup';
import { LevelDBTable } from "./LevelDBTable";
import { AbstractIteratorOptions } from "abstract-leveldown";
export declare class LevelDBDividend extends LevelDBTable<DividendEntry> implements DividendDAO {
    protected getLevelDB: (dbName: string) => Promise<LevelUp>;
    private indexForTrimming;
    private hasIndexed;
    constructor(getLevelDB: (dbName: string) => Promise<LevelUp>);
    /**
     * TECHNICAL
     */
    cleanCache(): void;
    triggerInit(): void;
    init(): Promise<void>;
    close(): Promise<void>;
    /**
     * INSERT
     */
    insert(record: DividendEntry): Promise<void>;
    insertBatch(records: DividendEntry[]): Promise<void>;
    private indexConsumptions;
    consume(filter: SindexEntry[]): Promise<void>;
    createMember(pub: string): Promise<void>;
    deleteMember(pub: string): Promise<void>;
    findForDump(criterion: any): Promise<SindexEntry[]>;
    findRawWithOrder(criterion: {
        pub?: string;
    }, sort: (string | (string | boolean)[])[]): Promise<DividendEntry[]>;
    findUdSourceByIdentifierPosAmountBase(identifier: string, pos: number, amount: number, base: number): Promise<SimpleTxInput[]>;
    getUDSource(identifier: string, pos: number): Promise<SimpleTxInput | null>;
    getUDSources(pub: string): Promise<UDSource[]>;
    getWrittenOn(blockstamp: string): Promise<DividendEntry[]>;
    getWrittenOnUDs(number: number): Promise<SimpleUdEntryForWallet[]>;
    produceDividend(blockNumber: number, dividend: number, unitbase: number, local_iindex: IindexEntry[]): Promise<SimpleUdEntryForWallet[]>;
    removeBlock(blockstamp: string): Promise<void>;
    revertUDs(number: number): Promise<{
        createdUDsDestroyedByRevert: SimpleUdEntryForWallet[];
        consumedUDsRecoveredByRevert: SimpleUdEntryForWallet[];
    }>;
    setMember(member: boolean, pub: string): Promise<void>;
    trimConsumedUDs(belowNumber: number): Promise<void>;
    listAll(): Promise<DividendEntry[]>;
    private static trimKey;
    count(options?: AbstractIteratorOptions): Promise<number>;
}
