import { FullIindexEntry, IindexEntry } from "../../../indexer";
import { LevelUp } from 'levelup';
import { LevelDBTable } from "./LevelDBTable";
import { IIndexDAO } from "../abstract/IIndexDAO";
import { OldIindexEntry } from "../../../db/OldIindexEntry";
export declare class LevelDBIindex extends LevelDBTable<IindexEntry[]> implements IIndexDAO {
    protected getLevelDB: (dbName: string) => Promise<LevelUp>;
    private indexForHash;
    private indexForUid;
    private indexForKick;
    private indexForWrittenOn;
    constructor(getLevelDB: (dbName: string) => Promise<LevelUp>);
    /**
     * TECHNICAL
     */
    init(): Promise<void>;
    close(): Promise<void>;
    /**
     * INSERT
     */
    insert(record: IindexEntry): Promise<void>;
    insertBatch(records: IindexEntry[]): Promise<void>;
    /**
     * Reduceable DAO
     */
    trimRecords(belowNumber: number): Promise<void>;
    /**
     * Generic DAO
     */
    findRawWithOrder(criterion: {
        pub?: string;
    }, sort: (string | (string | boolean)[])[]): Promise<IindexEntry[]>;
    getWrittenOn(blockstamp: string): Promise<IindexEntry[]>;
    removeBlock(blockstamp: string): Promise<void>;
    findByPub(pub: string): Promise<IindexEntry[]>;
    findByUid(uid: string): Promise<IindexEntry[]>;
    getFromPubkey(pub: string): Promise<FullIindexEntry | null>;
    getFromPubkeyOrUid(search: string): Promise<FullIindexEntry | null>;
    getFromUID(uid: string): Promise<FullIindexEntry | null>;
    getFullFromHash(hash: string): Promise<FullIindexEntry | null>;
    getFullFromPubkey(pub: string): Promise<FullIindexEntry>;
    getFullFromUID(uid: string): Promise<FullIindexEntry>;
    getMembers(): Promise<{
        pubkey: string;
        uid: string | null;
    }[]>;
    getToBeKickedPubkeys(): Promise<string[]>;
    reducable(pub: string): Promise<IindexEntry[]>;
    searchThoseMatching(search: string): Promise<OldIindexEntry[]>;
}
