import { FullMindexEntry, MindexEntry } from "../../../indexer";
import { LevelUp } from 'levelup';
import { LevelDBTable } from "./LevelDBTable";
import { MIndexDAO } from "../abstract/MIndexDAO";
export declare class LevelDBMindex extends LevelDBTable<MindexEntry[]> implements MIndexDAO {
    protected getLevelDB: (dbName: string) => Promise<LevelUp>;
    private indexForExpiresOn;
    private indexForRevokesOn;
    private indexForWrittenOn;
    constructor(getLevelDB: (dbName: string) => Promise<LevelUp>);
    /**
     * TECHNICAL
     */
    init(): Promise<void>;
    close(): Promise<void>;
    /**
     * INSERT
     */
    insert(record: MindexEntry): Promise<void>;
    insertBatch(records: MindexEntry[]): Promise<void>;
    /**
     * Reduceable DAO
     */
    trimRecords(belowNumber: number): Promise<void>;
    /**
     * Generic DAO
     */
    findRawWithOrder(criterion: {
        pub?: string;
    }, sort: (string | (string | boolean)[])[]): Promise<MindexEntry[]>;
    getWrittenOn(blockstamp: string): Promise<MindexEntry[]>;
    removeBlock(blockstamp: string): Promise<void>;
    findByPubAndChainableOnGt(pub: string, medianTime: number): Promise<MindexEntry[]>;
    findExpiresOnLteAndRevokesOnGt(medianTime: number): Promise<string[]>;
    findPubkeysThatShouldExpire(medianTime: number): Promise<{
        pub: string;
        created_on: string;
    }[]>;
    findRevokesOnLteAndRevokedOnIsNull(medianTime: number): Promise<string[]>;
    getReducedMS(pub: string): Promise<FullMindexEntry | null>;
    getReducedMSForImplicitRevocation(pub: string): Promise<FullMindexEntry | null>;
    getRevokedPubkeys(): Promise<string[]>;
    reducable(pub: string): Promise<MindexEntry[]>;
}
