import { LevelUp } from "levelup";
import { AbstractIteratorOptions } from "abstract-leveldown";
export declare class LevelDBTable<T> {
    private name;
    protected getLevelDB: (dbName: string) => Promise<LevelUp>;
    private db;
    constructor(name: string, getLevelDB: (dbName: string) => Promise<LevelUp>);
    cleanCache(): void;
    triggerInit(): void;
    close(): Promise<void>;
    init(): Promise<void>;
    get(k: string): Promise<T>;
    getOrNull(k: string): Promise<T | null>;
    del(k: string): Promise<void>;
    put(k: string, record: T): Promise<void>;
    batchInsert(records: T[], key: keyof T): Promise<void>;
    batchInsertWithKeyComputing(records: T[], keyComputing: (record: T) => string): Promise<void>;
    count(options?: AbstractIteratorOptions): Promise<number>;
    readAll(callback: (entry: T) => void, options?: AbstractIteratorOptions): Promise<void>;
    readAllKeyValue(callback: (entry: {
        key: string;
        value: T;
    }) => void, options?: AbstractIteratorOptions): Promise<void>;
    applyAllKeyValue(callback: (entry: {
        key: string;
        value: T;
    }) => Promise<void>, options?: AbstractIteratorOptions): Promise<void>;
    deleteWhere(options?: AbstractIteratorOptions): Promise<{
        key: string;
        value: T;
    }[]>;
    findAllKeys(options?: AbstractIteratorOptions): Promise<string[]>;
    findAllValues(options?: AbstractIteratorOptions): Promise<T[]>;
    findWhere(filter: (t: T) => boolean): Promise<T[]>;
    findWhereTransform<R>(filter: (t: T) => boolean, transform: (t: {
        key: string;
        value: T;
    }) => R): Promise<R[]>;
    dump(dumpValue?: (t: {
        key: string;
        value: T;
    }) => any): Promise<number>;
}
