import { LevelUp } from 'levelup';
import { LevelDBTable } from "./LevelDBTable";
import { DBWallet } from "../../../db/DBWallet";
import { WalletDAO } from "../abstract/WalletDAO";
export declare class LevelDBWallet extends LevelDBTable<DBWallet> implements WalletDAO {
    constructor(getLevelDB: (dbName: string) => Promise<LevelUp>);
    /**
     * INSERT
     */
    insert(record: DBWallet): Promise<void>;
    insertBatch(records: DBWallet[]): Promise<void>;
    getWallet(conditions: string): Promise<DBWallet | null>;
    listAll(): Promise<DBWallet[]>;
    saveWallet(wallet: DBWallet): Promise<DBWallet>;
}
