"use strict";
var __decorate = (this && this.__decorate) || function (decorators, target, key, desc) {
    var c = arguments.length, r = c < 3 ? target : desc === null ? desc = Object.getOwnPropertyDescriptor(target, key) : desc, d;
    if (typeof Reflect === "object" && typeof Reflect.decorate === "function") r = Reflect.decorate(decorators, target, key, desc);
    else for (var i = decorators.length - 1; i >= 0; i--) if (d = decorators[i]) r = (c < 3 ? d(r) : c > 3 ? d(target, key, r) : d(target, key)) || r;
    return c > 3 && r && Object.defineProperty(target, key, r), r;
};
Object.defineProperty(exports, "__esModule", { value: true });
const MonitorExecutionTime_1 = require("../../../debug/MonitorExecutionTime");
const LevelDBTable_1 = require("./LevelDBTable");
class LevelDBWallet extends LevelDBTable_1.LevelDBTable {
    constructor(getLevelDB) {
        super('level_wallet', getLevelDB);
    }
    /**
     * INSERT
     */
    async insert(record) {
        await this.insertBatch([record]);
    }
    async insertBatch(records) {
        await this.batchInsertWithKeyComputing(records, r => r.conditions);
    }
    getWallet(conditions) {
        return this.getOrNull(conditions);
    }
    listAll() {
        return this.findAllValues();
    }
    async saveWallet(wallet) {
        await this.put(wallet.conditions, wallet);
        return wallet;
    }
}
__decorate([
    MonitorExecutionTime_1.MonitorExecutionTime()
], LevelDBWallet.prototype, "insert", null);
__decorate([
    MonitorExecutionTime_1.MonitorExecutionTime()
], LevelDBWallet.prototype, "insertBatch", null);
exports.LevelDBWallet = LevelDBWallet;
//# sourceMappingURL=LevelDBWallet.js.map