import { LevelUp } from "levelup";
import { LevelDBTable } from "../LevelDBTable";
export interface WrittenOnData {
    writtenOn: number;
}
export declare class LevelDBWrittenOnIndexer<T extends WrittenOnData> extends LevelDBTable<string[]> {
    protected toKey: (t: T) => string;
    constructor(name: string, getLevelDB: (dbName: string) => Promise<LevelUp>, toKey: (t: T) => string);
    onInsert(records: T[]): Promise<void>;
    getWrittenOnKeys(writtenOn: number): Promise<string[] | null>;
    trim(writtenOn: number): Promise<void>;
    private static trimWrittenOnKey;
    deleteBelow(writtenOn: number): Promise<string[]>;
    deleteAt(writtenOn: number): Promise<string[]>;
}
