"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
const LevelDBDataIndex_1 = require("../generic/LevelDBDataIndex");
class LevelIIndexHashIndexer extends LevelDBDataIndex_1.LevelDBDataIndex {
    async onInsert(records) {
        await Promise.all(records
            .filter(e => e.op === 'CREATE' && e.hash)
            .map(async (e) => this.put(e.hash, [e.pub])));
    }
    async onRemove(records) {
        await Promise.all(records
            .filter(e => e.op === 'CREATE' && e.hash)
            .map(async (e) => this.del(e.hash)));
    }
    async getByHash(hash) {
        const res = await this.getOrNull(hash);
        return res && res[0];
    }
}
exports.LevelIIndexHashIndexer = LevelIIndexHashIndexer;
//# sourceMappingURL=LevelIIndexHashIndexer.js.map