"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
const LevelDBDataIndex_1 = require("../generic/LevelDBDataIndex");
class LevelIIndexUidIndexer extends LevelDBDataIndex_1.LevelDBDataIndex {
    async onInsert(records) {
        await Promise.all(records
            .filter(e => e.op === 'CREATE' && e.uid)
            .map(async (e) => this.put(e.uid, [e.pub])));
    }
    async onRemove(records) {
        await Promise.all(records
            .filter(e => e.op === 'CREATE' && e.uid)
            .map(async (e) => this.del(e.uid)));
    }
    async getPubByUid(uid) {
        const res = await this.getOrNull(uid);
        return res && res[0];
    }
}
exports.LevelIIndexUidIndexer = LevelIIndexUidIndexer;
//# sourceMappingURL=LevelIIndexUidIndexer.js.map