import { LevelDBDataIndex } from "../generic/LevelDBDataIndex";
import { MindexEntry } from "../../../../indexer";
export declare type Pubkey = string;
export declare class LevelMIndexExpiresOnIndexer extends LevelDBDataIndex<Pubkey[], MindexEntry> {
    onInsert(records: MindexEntry[], prevState: MindexEntry[]): Promise<void>;
    onRemove(records: MindexEntry[], newState: MindexEntry[]): Promise<void>;
    addAllKeysToExpiresOn(expiresOn: number, pubkeys: Pubkey[]): Promise<void>;
    removeAllKeysFromExpiresOn(expiresOn: number, pubkeys: Pubkey[]): Promise<void>;
    findExpiresOnLte(medianTime: number): Promise<string[]>;
    private static trimKey;
}
