export declare type SqlFieldType = 'BOOLEAN' | 'VARCHAR' | 'TEXT' | 'JSON' | 'CHAR' | 'INT';
export declare class SqlFieldDefinition {
    readonly type: SqlFieldType;
    readonly indexed: boolean;
    readonly nullable: boolean;
    readonly length: number;
    constructor(type: SqlFieldType, indexed?: boolean, nullable?: boolean, length?: number);
}
export declare class SqlNotNullableFieldDefinition extends SqlFieldDefinition {
    readonly type: SqlFieldType;
    readonly indexed: boolean;
    readonly length: number;
    constructor(type: SqlFieldType, indexed?: boolean, length?: number);
}
export declare class SqlNullableFieldDefinition extends SqlFieldDefinition {
    readonly type: SqlFieldType;
    readonly indexed: boolean;
    readonly length: number;
    constructor(type: SqlFieldType, indexed?: boolean, length?: number);
}
