import { SQLiteDriver } from "../../drivers/SQLiteDriver";
import { SqliteTable } from "./SqliteTable";
import { DividendDAO, DividendEntry, UDSource } from "../abstract/DividendDAO";
import { IindexEntry, SimpleTxInput, SimpleUdEntryForWallet, SindexEntry } from "../../../indexer";
export declare class SqliteDividend extends SqliteTable<DividendEntry> implements DividendDAO {
    constructor(getSqliteDB: (dbName: string) => Promise<SQLiteDriver>);
    /**
     * TECHNICAL
     */
    cleanCache(): void;
    triggerInit(): void;
    /**
     * INSERT
     */
    insert(record: DividendEntry): Promise<void>;
    insertBatch(records: DividendEntry[]): Promise<void>;
    private find;
    consume(filter: SindexEntry[]): Promise<void>;
    createMember(pub: string): Promise<void>;
    deleteMember(pub: string): Promise<void>;
    findForDump(criterion: any): Promise<SindexEntry[]>;
    findRawWithOrder(criterion: {
        pub?: string;
    }, sort: (string | (string | boolean)[])[]): Promise<DividendEntry[]>;
    findUdSourceByIdentifierPosAmountBase(identifier: string, pos: number, amount: number, base: number): Promise<SimpleTxInput[]>;
    getUDSource(identifier: string, pos: number): Promise<SimpleTxInput | null>;
    getUDSources(pub: string): Promise<UDSource[]>;
    getWrittenOn(blockstamp: string): Promise<DividendEntry[]>;
    getWrittenOnUDs(number: number): Promise<SimpleUdEntryForWallet[]>;
    produceDividend(blockNumber: number, dividend: number, unitbase: number, local_iindex: IindexEntry[]): Promise<SimpleUdEntryForWallet[]>;
    removeBlock(blockstamp: string): Promise<void>;
    revertUDs(number: number): Promise<{
        createdUDsDestroyedByRevert: SimpleUdEntryForWallet[];
        consumedUDsRecoveredByRevert: SimpleUdEntryForWallet[];
    }>;
    setMember(member: boolean, pub: string): Promise<void>;
    trimConsumedUDs(belowNumber: number): Promise<void>;
    listAll(): Promise<DividendEntry[]>;
}
