import { FullIindexEntry, IindexEntry } from "../../../indexer";
import { SQLiteDriver } from "../../drivers/SQLiteDriver";
import { IIndexDAO } from "../abstract/IIndexDAO";
import { OldIindexEntry } from "../../../db/OldIindexEntry";
import { SqliteTable } from "./SqliteTable";
export declare class SqliteIIndex extends SqliteTable<IindexEntry> implements IIndexDAO {
    constructor(getSqliteDB: (dbName: string) => Promise<SQLiteDriver>);
    /**
     * TECHNICAL
     */
    cleanCache(): void;
    triggerInit(): void;
    /**
     * INSERT
     */
    insert(record: IindexEntry): Promise<void>;
    insertBatch(records: IindexEntry[]): Promise<void>;
    /**
     * DELETE
     */
    removeBlock(blockstamp: string): Promise<void>;
    trimRecords(belowNumber: number): Promise<void>;
    /**
     * FIND
     */
    getWrittenOn(blockstamp: string): Promise<IindexEntry[]>;
    findRawWithOrder(criterion: {
        pub?: string;
    }, sort: (string | (string | boolean)[])[]): Promise<IindexEntry[]>;
    private find;
    /**
     * OTHER
     */
    reducable(pub: string): Promise<IindexEntry[]>;
    findByPub(pub: string): Promise<IindexEntry[]>;
    findByUid(uid: string): Promise<IindexEntry[]>;
    getFromPubkey(pub: string): Promise<FullIindexEntry | null>;
    getFromPubkeyOrUid(search: string): Promise<FullIindexEntry | null>;
    getFromUID(uid: string): Promise<FullIindexEntry | null>;
    getFullFromHash(hash: string): Promise<FullIindexEntry>;
    getFullFromPubkey(pub: string): Promise<FullIindexEntry>;
    getFullFromUID(uid: string): Promise<FullIindexEntry>;
    getMembers(): Promise<{
        pubkey: string;
        uid: string | null;
    }[]>;
    getToBeKickedPubkeys(): Promise<string[]>;
    searchThoseMatching(search: string): Promise<OldIindexEntry[]>;
}
