import { FullMindexEntry, MindexEntry } from "../../../indexer";
import { SQLiteDriver } from "../../drivers/SQLiteDriver";
import { MIndexDAO } from "../abstract/MIndexDAO";
import { SqliteTable } from "./SqliteTable";
export declare class SqliteMIndex extends SqliteTable<MindexEntry> implements MIndexDAO {
    private readonly p2;
    private d2;
    constructor(getSqliteDB: (dbName: string) => Promise<SQLiteDriver>);
    /**
     * TECHNICAL
     */
    cleanCache(): void;
    init(): Promise<void>;
    triggerInit(): void;
    /**
     * INSERT
     */
    insert(record: MindexEntry): Promise<void>;
    insertBatch(records: MindexEntry[]): Promise<void>;
    insertD2(cCreates: string): Promise<void>;
    updateD2(r: MindexEntry): Promise<void>;
    /**
     * DELETE
     */
    removeBlock(blockstamp: string): Promise<void>;
    trimRecords(belowNumber: number): Promise<void>;
    /**
     * FIND
     */
    findByPubAndChainableOnGt(pub: string, medianTime: number): Promise<MindexEntry[]>;
    findPubkeysThatShouldExpire(medianTime: number): Promise<{
        pub: string;
        created_on: string;
    }[]>;
    findRevokesOnLteAndRevokedOnIsNull(medianTime: number): Promise<string[]>;
    getWrittenOn(blockstamp: string): Promise<MindexEntry[]>;
    findRawWithOrder(criterion: {
        pub?: string;
    }, sort: (string | (string | boolean)[])[]): Promise<MindexEntry[]>;
    private find;
    getReducedMSForImplicitRevocation(pub: string): Promise<FullMindexEntry | null>;
    getReducedMSForMembershipExpiry(pub: string): Promise<FullMindexEntry | null>;
    getRevokedPubkeys(): Promise<string[]>;
    /**
     * OTHER
     */
    reducable(pub: string): Promise<MindexEntry[]>;
    findExpiresOnLteAndRevokesOnGt(medianTime: number): Promise<string[]>;
    getReducedMS(pub: string): Promise<FullMindexEntry | null>;
}
