import { SQLiteDriver } from "../../drivers/SQLiteDriver";
import { SqliteTable } from "./SqliteTable";
import { DBPeer } from "../../../db/DBPeer";
import { PeerDAO } from "../abstract/PeerDAO";
export declare class SqlitePeers extends SqliteTable<DBPeer> implements PeerDAO {
    constructor(getSqliteDB: (dbName: string) => Promise<SQLiteDriver>);
    /**
     * TECHNICAL
     */
    insert(record: DBPeer): Promise<void>;
    insertBatch(records: DBPeer[]): Promise<void>;
    cleanCache(): void;
    countNonWoTPeers(): Promise<number>;
    deleteNonWotPeersWhoseLastContactIsAbove(threshold: number): Promise<void>;
    getPeer(pubkey: string): Promise<DBPeer>;
    getPeersWithEndpointsLike(ep: string): Promise<DBPeer[]>;
    listAll(): Promise<DBPeer[]>;
    removeAll(): Promise<void>;
    removePeerByPubkey(pubkey: string): Promise<void>;
    savePeer(peer: DBPeer): Promise<DBPeer>;
    triggerInit(): void;
    withUPStatus(): Promise<DBPeer[]>;
}
