"use strict";
var __decorate = (this && this.__decorate) || function (decorators, target, key, desc) {
    var c = arguments.length, r = c < 3 ? target : desc === null ? desc = Object.getOwnPropertyDescriptor(target, key) : desc, d;
    if (typeof Reflect === "object" && typeof Reflect.decorate === "function") r = Reflect.decorate(decorators, target, key, desc);
    else for (var i = decorators.length - 1; i >= 0; i--) if (d = decorators[i]) r = (c < 3 ? d(r) : c > 3 ? d(target, key, r) : d(target, key)) || r;
    return c > 3 && r && Object.defineProperty(target, key, r), r;
};
Object.defineProperty(exports, "__esModule", { value: true });
const MonitorExecutionTime_1 = require("../../../debug/MonitorExecutionTime");
const SqliteTable_1 = require("./SqliteTable");
const SqlFieldDefinition_1 = require("./SqlFieldDefinition");
class SqlitePeers extends SqliteTable_1.SqliteTable {
    constructor(getSqliteDB) {
        super('peers', {
            'version': new SqlFieldDefinition_1.SqlNullableFieldDefinition('INT', false),
            'currency': new SqlFieldDefinition_1.SqlNullableFieldDefinition('VARCHAR', false, 100),
            'status': new SqlFieldDefinition_1.SqlNullableFieldDefinition('VARCHAR', true, 10),
            'statusTS': new SqlFieldDefinition_1.SqlNullableFieldDefinition('INT', false),
            'hash': new SqlFieldDefinition_1.SqlNullableFieldDefinition('VARCHAR', false, 70),
            'first_down': new SqlFieldDefinition_1.SqlNullableFieldDefinition('INT', false),
            'last_try': new SqlFieldDefinition_1.SqlNullableFieldDefinition('INT', true),
            'lastContact': new SqlFieldDefinition_1.SqlNullableFieldDefinition('INT', false),
            'pubkey': new SqlFieldDefinition_1.SqlNullableFieldDefinition('VARCHAR', true, 50),
            'block': new SqlFieldDefinition_1.SqlNullableFieldDefinition('VARCHAR', false, 100),
            'signature': new SqlFieldDefinition_1.SqlNullableFieldDefinition('VARCHAR', false, 100),
            'endpoints': new SqlFieldDefinition_1.SqlNullableFieldDefinition('JSON', true),
            'raw': new SqlFieldDefinition_1.SqlNullableFieldDefinition('TEXT', false),
            'nonWoT': new SqlFieldDefinition_1.SqlNullableFieldDefinition('BOOLEAN', false),
        }, getSqliteDB);
    }
    /**
     * TECHNICAL
     */
    async insert(record) {
        await this.insertInTable(this.driver, record);
    }
    async insertBatch(records) {
        if (records.length) {
            return this.insertBatchInTable(this.driver, records);
        }
    }
    cleanCache() {
    }
    async countNonWoTPeers() {
        return (await this.driver.sqlRead('SELECT COUNT(*) as _count FROM peers WHERE nonWoT', []))[0]['_count'];
    }
    deleteNonWotPeersWhoseLastContactIsAbove(threshold) {
        return this.driver.sqlWrite('DELETE FROM peers WHERE (nonWoT OR nonWoT IS NULL) AND lastContact <= ?', [threshold]);
    }
    async getPeer(pubkey) {
        return (await this.findEntities('SELECT * FROM peers WHERE pubkey = ?', [pubkey]))[0];
    }
    getPeersWithEndpointsLike(ep) {
        return this.findEntities('SELECT * FROM peers WHERE endpoints LIKE ?', [`%${ep}%`]);
    }
    listAll() {
        return this.findEntities('SELECT * FROM peers', []);
    }
    removeAll() {
        return this.driver.sqlWrite('DELETE FROM peers', []);
    }
    removePeerByPubkey(pubkey) {
        return this.driver.sqlWrite('DELETE FROM peers WHERE pubkey = ?', [pubkey]);
    }
    async savePeer(peer) {
        await this.driver.sqlWrite('DELETE FROM peers WHERE pubkey = ?', [peer.pubkey]);
        await this.insert(peer);
        return peer;
    }
    triggerInit() {
    }
    withUPStatus() {
        return this.findEntities('SELECT * FROM peers WHERE status = ?', ['UP']);
    }
}
__decorate([
    MonitorExecutionTime_1.MonitorExecutionTime()
], SqlitePeers.prototype, "insert", null);
__decorate([
    MonitorExecutionTime_1.MonitorExecutionTime()
], SqlitePeers.prototype, "insertBatch", null);
exports.SqlitePeers = SqlitePeers;
//# sourceMappingURL=SqlitePeers.js.map