import { FullSindexEntry, SimpleTxEntryForWallet, SimpleTxInput, SindexEntry } from "../../../indexer";
import { SQLiteDriver } from "../../drivers/SQLiteDriver";
import { SqliteTable } from "./SqliteTable";
import { SIndexDAO } from "../abstract/SIndexDAO";
export declare class SqliteSIndex extends SqliteTable<SindexEntry> implements SIndexDAO {
    constructor(getSqliteDB: (dbName: string) => Promise<SQLiteDriver>);
    /**
     * TECHNICAL
     */
    cleanCache(): void;
    triggerInit(): void;
    /**
     * INSERT
     */
    insert(record: SindexEntry): Promise<void>;
    insertBatch(records: SindexEntry[]): Promise<void>;
    /**
     * DELETE
     */
    removeBlock(blockstamp: string): Promise<void>;
    trimRecords(belowNumber: number): Promise<void>;
    /**
     * FIND
     */
    getWrittenOn(blockstamp: string): Promise<SindexEntry[]>;
    findRawWithOrder(criterion: {
        pub?: string;
    }, sort: (string | (string | boolean)[])[]): Promise<SindexEntry[]>;
    private find;
    /**
     * OTHER
     */
    findByIdentifier(identifier: string): Promise<SindexEntry[]>;
    findByPos(pos: number): Promise<SindexEntry[]>;
    findTxSourceByIdentifierPosAmountBase(identifier: string, pos: number, amount: number, base: number): Promise<SimpleTxInput[]>;
    getAvailableForConditions(conditionsStr: string): Promise<SindexEntry[]>;
    getAvailableForPubkey(pubkey: string): Promise<{
        amount: number;
        base: number;
        conditions: string;
        identifier: string;
        pos: number;
    }[]>;
    getTxSource(identifier: string, pos: number): Promise<FullSindexEntry | null>;
    getWrittenOnTxs(blockstamp: string): Promise<SimpleTxEntryForWallet[]>;
    trimConsumedSource(belowNumber: number): Promise<void>;
}
