import { SQLiteDriver } from "../../drivers/SQLiteDriver";
import { SqliteTable } from "./SqliteTable";
import { DBTx } from "../../../db/DBTx";
import { TxsDAO } from "../abstract/TxsDAO";
import { SandBox } from "../../sqliteDAL/SandBox";
import { TransactionDTO } from "../../../dto/TransactionDTO";
export declare class SqliteTransactions extends SqliteTable<DBTx> implements TxsDAO {
    constructor(getSqliteDB: (dbName: string) => Promise<SQLiteDriver>);
    /**
     * TECHNICAL
     */
    insert(record: DBTx): Promise<void>;
    insertBatch(records: DBTx[]): Promise<void>;
    sandbox: SandBox<{
        issuers: string[];
        output_base: number;
        output_amount: number;
    }>;
    addLinked(tx: TransactionDTO, block_number: number, time: number): Promise<DBTx>;
    addPending(dbTx: DBTx): Promise<DBTx>;
    cleanCache(): void;
    findRawWithOrder(criterion: {
        pub?: string;
    }, sort: (string | (string | boolean)[])[]): Promise<DBTx[]>;
    getAllPending(versionMin: number): Promise<DBTx[]>;
    getLinkedWithIssuer(pubkey: string): Promise<DBTx[]>;
    getLinkedWithRecipient(pubkey: string): Promise<DBTx[]>;
    getPendingWithIssuer(pubkey: string): Promise<DBTx[]>;
    getPendingWithRecipient(pubkey: string): Promise<DBTx[]>;
    getTX(hash: string): Promise<DBTx>;
    getWrittenOn(blockstamp: string): Promise<DBTx[]>;
    removeAll(): Promise<void>;
    removeBlock(blockstamp: string): Promise<void>;
    removeTX(hash: string): Promise<void>;
    triggerInit(): void;
    trimExpiredNonWrittenTxs(limitTime: number): Promise<void>;
    /**************************
     * SANDBOX STUFF
     */
    getSandboxTxs(): Promise<DBTx[]>;
    getSandboxRoom(): Promise<number>;
    setSandboxSize(maxSize: number): void;
}
