import { SQLiteDriver } from "../../drivers/SQLiteDriver";
import { SqliteTable } from "./SqliteTable";
import { WalletDAO } from "../abstract/WalletDAO";
import { DBWallet } from "../../../db/DBWallet";
export declare class SqliteWallet extends SqliteTable<DBWallet> implements WalletDAO {
    constructor(getSqliteDB: (dbName: string) => Promise<SQLiteDriver>);
    /**
     * TECHNICAL
     */
    cleanCache(): void;
    triggerInit(): void;
    /**
     * INSERT
     */
    insert(record: DBWallet): Promise<void>;
    insertBatch(records: DBWallet[]): Promise<void>;
    private find;
    getWallet(conditions: string): Promise<DBWallet>;
    saveWallet(wallet: DBWallet): Promise<DBWallet>;
    listAll(): Promise<DBWallet[]>;
}
