"use strict";
var __decorate = (this && this.__decorate) || function (decorators, target, key, desc) {
    var c = arguments.length, r = c < 3 ? target : desc === null ? desc = Object.getOwnPropertyDescriptor(target, key) : desc, d;
    if (typeof Reflect === "object" && typeof Reflect.decorate === "function") r = Reflect.decorate(decorators, target, key, desc);
    else for (var i = decorators.length - 1; i >= 0; i--) if (d = decorators[i]) r = (c < 3 ? d(r) : c > 3 ? d(target, key, r) : d(target, key)) || r;
    return c > 3 && r && Object.defineProperty(target, key, r), r;
};
Object.defineProperty(exports, "__esModule", { value: true });
const MonitorExecutionTime_1 = require("../../../debug/MonitorExecutionTime");
const SqliteTable_1 = require("./SqliteTable");
const SqlFieldDefinition_1 = require("./SqlFieldDefinition");
class SqliteWallet extends SqliteTable_1.SqliteTable {
    constructor(getSqliteDB) {
        super('wallet', {
            'conditions': new SqlFieldDefinition_1.SqlNotNullableFieldDefinition('VARCHAR', true, 1000),
            'balance': new SqlFieldDefinition_1.SqlNotNullableFieldDefinition('INT', true),
        }, getSqliteDB);
    }
    /**
     * TECHNICAL
     */
    cleanCache() {
    }
    triggerInit() {
    }
    /**
     * INSERT
     */
    async insert(record) {
        await this.insertInTable(this.driver, record);
    }
    async insertBatch(records) {
        if (records.length) {
            return this.insertBatchInTable(this.driver, records);
        }
    }
    async find(sql, params) {
        return (await this.driver.sqlRead(sql, params)).map(r => {
            return {
                conditions: r.conditions,
                balance: r.balance,
            };
        });
    }
    async getWallet(conditions) {
        return (await this.find('SELECT * FROM wallet WHERE conditions = ?', [conditions]))[0];
    }
    async saveWallet(wallet) {
        await this.insert(wallet);
        return wallet;
    }
    listAll() {
        return this.find('SELECT * FROM wallet', []);
    }
}
__decorate([
    MonitorExecutionTime_1.MonitorExecutionTime()
], SqliteWallet.prototype, "insert", null);
__decorate([
    MonitorExecutionTime_1.MonitorExecutionTime()
], SqliteWallet.prototype, "insertBatch", null);
exports.SqliteWallet = SqliteWallet;
//# sourceMappingURL=SqliteWallet.js.map