import { AbstractSQLite } from "./AbstractSQLite";
import { SQLiteDriver } from "../drivers/SQLiteDriver";
import { DBBlock } from "../../db/DBBlock";
export declare class BlockDAL extends AbstractSQLite<DBBlock> {
    private current;
    constructor(driver: SQLiteDriver);
    init(): Promise<void>;
    cleanCache(): void;
    getCurrent(): Promise<DBBlock>;
    getBlock(number: string | number): Promise<DBBlock | null>;
    getAbsoluteBlock(number: number, hash: string): Promise<DBBlock | null>;
    getBlocks(start: number, end: number): Promise<DBBlock[]>;
    lastBlockOfIssuer(issuer: string): Promise<DBBlock>;
    getCountOfBlocksIssuedBy(issuer: string): Promise<any>;
    getPotentialForkBlocks(numberStart: number, medianTimeStart: number, maxNumber: number): Promise<DBBlock[]>;
    getPotentialRoots(): Promise<DBBlock[]>;
    saveBlock(block: DBBlock): Promise<void>;
    saveSideBlock(block: DBBlock): Promise<void>;
    private saveBlockAs;
    setSideBlock(number: number, previousBlock: DBBlock | null): Promise<void>;
    getNextForkBlocks(number: number, hash: string): Promise<DBBlock[]>;
}
