import { SQLiteDriver } from "../drivers/SQLiteDriver";
import { AbstractSQLite } from "./AbstractSQLite";
import { SandBox } from './SandBox';
import { DBDocument } from './DocumentDAL';
export interface DBMembership extends DBDocument {
    membership: string;
    issuer: string;
    number: number;
    blockNumber: number;
    blockHash: string;
    userid: string;
    certts: string;
    block: string;
    fpr: string;
    idtyHash: string;
    written: boolean;
    written_number: number | null;
    expires_on: number;
    signature: string;
    expired: boolean | null;
    block_number: number;
}
export declare class MembershipDAL extends AbstractSQLite<DBMembership> {
    constructor(driver: SQLiteDriver);
    init(): Promise<void>;
    getMembershipsOfIssuer(issuer: string): Promise<DBMembership[]>;
    getPendingINOfTarget(hash: string): Promise<DBMembership[]>;
    getPendingIN(): Promise<DBMembership[]>;
    getPendingOUT(): Promise<DBMembership[]>;
    savePendingMembership(ms: DBMembership): Promise<void>;
    deleteMS(ms: DBMembership): Promise<void>;
    trimExpiredMemberships(medianTime: number): Promise<void>;
    /**************************
     * SANDBOX STUFF
     */
    getSandboxMemberships(): Promise<DBMembership[]>;
    sandbox: SandBox<{
        block_number: number;
        issuers: string[];
    }>;
    getSandboxRoom(): Promise<number>;
    setSandboxSize(maxSize: number): void;
}
