import { AbstractSQLite } from "./AbstractSQLite";
import { SQLiteDriver } from "../drivers/SQLiteDriver";
import { ConfDTO } from "../../dto/ConfDTO";
export interface DBMeta {
    id: number;
    version: number;
}
export declare class MetaDAL extends AbstractSQLite<DBMeta> {
    driverCopy: SQLiteDriver;
    constructor(driver: SQLiteDriver);
    private migrations;
    init(): Promise<void>;
    private executeMigration;
    upgradeDatabase(conf: ConfDTO): Promise<void>;
    getRow(): Promise<DBMeta>;
    getVersion(): Promise<number>;
    cleanData(): Promise<void>;
}
