import { AbstractSQLite } from "../AbstractSQLite";
import { DBHead } from "../../../db/DBHead";
import { SQLiteDriver } from "../../drivers/SQLiteDriver";
export declare class BIndexDAL extends AbstractSQLite<DBHead> {
    constructor(driver: SQLiteDriver);
    init(): Promise<void>;
    /**
     * Get HEAD~n
     * @param n Position
     */
    head(n: number): Promise<DBHead>;
    /**
     * Get the last record available in bindex
     */
    tail(): Promise<DBHead>;
    /**
     * Get HEAD~n..m
     * @param n
     * @param m
     */
    range(n: number, m: number): Promise<DBHead[]>;
    removeBlock(number: number): Promise<void>;
    trimBlocks(maxnumber: number): Promise<void>;
}
