import { SQLiteDriver } from "../../drivers/SQLiteDriver";
import { FullIindexEntry, IindexEntry } from "../../../indexer";
import { AbstractSQLite } from "../AbstractSQLite";
export interface OldIindexEntry extends IindexEntry {
    pubkey: string;
    buid: string | null;
    revocation_sig: string | null;
}
export declare class IIndexDAL extends AbstractSQLite<IindexEntry> {
    constructor(driver: SQLiteDriver);
    init(): Promise<void>;
    getMembers(): Promise<any>;
    getMembersPubkeys(): Promise<IindexEntry[]>;
    getToBeKickedPubkeys(): Promise<any>;
    searchThoseMatching(search: string): Promise<OldIindexEntry[]>;
    getFromPubkey(pubkey: string): Promise<FullIindexEntry | null>;
    getFromUID(uid: string, retrieveOnPubkey?: boolean): Promise<OldIindexEntry | null>;
    getFullFromPubkey(pub: string): Promise<FullIindexEntry>;
    getFullFromUID(uid: string): Promise<FullIindexEntry | null>;
    getFullFromHash(hash: string): Promise<FullIindexEntry | null>;
    reducable(pub: string): Promise<IindexEntry[]>;
    removeBlock(blockstamp: string): Promise<void>;
    private entityOrNull;
    private toCorrectEntity;
    getFromPubkeyOrUid(search: string): Promise<FullIindexEntry | null>;
}
