"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
class DBTx {
    static fromTransactionDTO(tx) {
        const dbTx = new DBTx();
        dbTx.hash = tx.hash;
        dbTx.locktime = tx.locktime;
        dbTx.version = tx.version;
        dbTx.currency = tx.currency;
        dbTx.blockstamp = tx.blockstamp;
        dbTx.blockstampTime = tx.blockstampTime;
        dbTx.comment = tx.comment || "";
        dbTx.inputs = tx.inputs;
        dbTx.unlocks = tx.unlocks;
        dbTx.outputs = tx.outputs;
        dbTx.issuers = tx.issuers;
        dbTx.signatures = tx.signatures;
        dbTx.recipients = tx.outputsAsRecipients();
        dbTx.written = false;
        dbTx.removed = false;
        dbTx.output_base = tx.output_base;
        dbTx.output_amount = tx.output_amount;
        return dbTx;
    }
    static setRecipients(txs) {
        // Each transaction must have a good "recipients" field for future searchs
        txs.forEach((tx) => tx.recipients = DBTx.outputs2recipients(tx));
    }
    static outputs2recipients(tx) {
        return tx.outputs.map(function (out) {
            const recipent = out.match('SIG\\((.*)\\)');
            return (recipent && recipent[1]) || 'UNKNOWN';
        });
    }
}
exports.DBTx = DBTx;
//# sourceMappingURL=DBTx.js.map