"use strict";
// Source file from duniter: Crypto-currency software to manage libre currency such as Ğ1
// Copyright (C) 2018  Cedric Moreau <cem.moreau@gmail.com>
//
// This program is free software: you can redistribute it and/or modify
// it under the terms of the GNU Affero General Public License as published by
// the Free Software Foundation, either version 3 of the License, or
// (at your option) any later version.
//
// This program is distributed in the hope that it will be useful,
// but WITHOUT ANY WARRANTY; without even the implied warranty of
// MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
// GNU Affero General Public License for more details.
Object.defineProperty(exports, "__esModule", { value: true });
const logger_1 = require("../logger");
const ProcessCpuProfiler_1 = require("../../ProcessCpuProfiler");
const other_constants_1 = require("../other_constants");
const theLogger = logger_1.NewLogger();
exports.MonitorLokiExecutionTime = function (dumpFirstParam = false) {
    return function (target, propertyKey, descriptor) {
        if (other_constants_1.OtherConstants.ENABLE_LOKI_MONITORING) {
            const original = descriptor.value;
            if (original.__proto__.constructor.name === "AsyncFunction") {
                descriptor.value = async function (...args) {
                    const that = this;
                    const now = ProcessCpuProfiler_1.getMicrosecondsTime();
                    const result = await original.apply(this, args);
                    if (dumpFirstParam) {
                        theLogger.trace('[loki][%s][%s] => %sµs', that.collectionName, propertyKey, (ProcessCpuProfiler_1.getMicrosecondsTime() - now), args && args[0]);
                    }
                    else {
                        theLogger.trace('[loki][%s][%s] => %sµs', that.collectionName, propertyKey, (ProcessCpuProfiler_1.getMicrosecondsTime() - now));
                    }
                    return result;
                };
            }
            else {
                throw Error("Monitoring a Loki synchronous function is not allowed.");
            }
        }
    };
};
//# sourceMappingURL=MonitorLokiExecutionTime.js.map