import { TransactionDTO } from "./TransactionDTO";
import { CurrencyConfDTO } from "./ConfDTO";
import { Cloneable } from "./Cloneable";
export declare class BlockDTO implements Cloneable {
    clone(): any;
    version: number;
    number: number;
    currency: string;
    hash: string;
    inner_hash: string;
    previousHash: string;
    issuer: string;
    previousIssuer: string;
    dividend: number | null;
    time: number;
    powMin: number;
    unitbase: number;
    membersCount: number;
    issuersCount: number;
    issuersFrame: number;
    issuersFrameVar: number;
    identities: string[];
    joiners: string[];
    actives: string[];
    leavers: string[];
    revoked: string[];
    excluded: string[];
    certifications: string[];
    transactions: TransactionDTO[];
    medianTime: number;
    nonce: number;
    fork: boolean;
    parameters: string;
    signature: string;
    monetaryMass: number;
    UDTime: number;
    constructor();
    json(): {
        version: number;
        nonce: number;
        number: number;
        powMin: number;
        time: number;
        medianTime: number;
        membersCount: number;
        monetaryMass: number;
        unitbase: number;
        issuersCount: number;
        issuersFrame: number;
        issuersFrameVar: number;
        len: number;
        currency: string;
        issuer: string;
        signature: string;
        hash: string;
        parameters: string;
        previousHash: string;
        previousIssuer: string;
        inner_hash: string;
        dividend: number | null;
        identities: string[];
        joiners: string[];
        actives: string[];
        leavers: string[];
        revoked: string[];
        excluded: string[];
        certifications: string[];
        transactions: {
            version: number;
            currency: string;
            locktime: number;
            blockstamp: string;
            blockstampTime: number;
            issuers: string[];
            inputs: string[];
            outputs: string[];
            unlocks: string[];
            signatures: string[];
            comment: string;
        }[];
    };
    readonly len: number;
    getInlineIdentity(pubkey: string): string | null;
    getRawUnSigned(): string;
    getRawSigned(): string;
    getSignedPart(): string;
    getSignedPartSigned(): string;
    getRawInnerPart(): string;
    getHash(): string;
    readonly blockstamp: string;
    static fromJSONObject(obj: any): BlockDTO;
    static getConf(block: BlockDTO): CurrencyConfDTO;
    static getLen(block: any): number;
    static getHash(block: any): string;
    static blockstamp(b: {
        number: number;
        hash: string;
    }): string;
}
