import { Cloneable } from "./Cloneable";
export declare class ShortCertificationDTO {
    pubkey: string;
    block_number: number;
    sig: string;
    idty_issuer: string;
    constructor(pubkey: string, block_number: number, sig: string, idty_issuer: string);
    readonly issuer: string;
    readonly from: string;
    readonly to: string;
}
export declare class CertificationDTO extends ShortCertificationDTO implements Cloneable {
    version: number;
    currency: string;
    pubkey: string;
    buid: string;
    sig: string;
    idty_issuer: string;
    idty_uid: string;
    idty_buid: string;
    idty_sig: string;
    clone(): any;
    constructor(version: number, currency: string, pubkey: string, buid: string, sig: string, idty_issuer: string, idty_uid: string, idty_buid: string, idty_sig: string);
    getTargetHash(): string;
    getRawUnSigned(): string;
    getRawSigned(): string;
    json(): {
        "issuer": string;
        "timestamp": string;
        "sig": string;
        "target": {
            "issuer": string;
            "uid": string;
            "timestamp": string;
            "sig": string;
        };
    };
    inline(): string;
    static fromInline(inline: string): ShortCertificationDTO;
    static fromJSONObject(obj: any): CertificationDTO;
    getHash(): string;
}
