"use strict";
// Source file from duniter: Crypto-currency software to manage libre currency such as Ğ1
// Copyright (C) 2018  Cedric Moreau <cem.moreau@gmail.com>
//
// This program is free software: you can redistribute it and/or modify
// it under the terms of the GNU Affero General Public License as published by
// the Free Software Foundation, either version 3 of the License, or
// (at your option) any later version.
//
// This program is distributed in the hope that it will be useful,
// but WITHOUT ANY WARRANTY; without even the implied warranty of
// MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
// GNU Affero General Public License for more details.
Object.defineProperty(exports, "__esModule", { value: true });
const constants_1 = require("../common-libs/constants");
const proxy_1 = require("../proxy");
const underscore_1 = require("../common-libs/underscore");
const constants = require('../constants');
class ConfDTO {
    constructor(loglevel, currency, endpoints, rmEndpoints, rootoffset, upInterval, cpu, nbCores, prefix, powSecurityRetryDelay, powMaxHandicap, c, dt, dtReeval, dtDiffEval, ud0, udTime0, udReevalTime0, stepMax, sigPeriod, sigReplay, msPeriod, sigValidity, msValidity, sigQty, sigStock, xpercent, percentRot, powDelay, avgGenTime, medianTimeBlocks, httplogs, timeout, isolate, forksize, idtyWindow, msWindow, sigWindow, switchOnHeadAdvance, pair, oldPair, salt, passwd, remoteport, remotehost, remoteipv4, remoteipv6, host, port, ipv4, ipv6, dos, upnp, homename, memory, nobma, bmaWithCrawler, nonWoTPeersLimit, proxiesConf, ws2p, powNoSecurity = false, storage = {
        transactions: false,
        wotwizard: false,
    }) {
        this.loglevel = loglevel;
        this.currency = currency;
        this.endpoints = endpoints;
        this.rmEndpoints = rmEndpoints;
        this.rootoffset = rootoffset;
        this.upInterval = upInterval;
        this.cpu = cpu;
        this.nbCores = nbCores;
        this.prefix = prefix;
        this.powSecurityRetryDelay = powSecurityRetryDelay;
        this.powMaxHandicap = powMaxHandicap;
        this.c = c;
        this.dt = dt;
        this.dtReeval = dtReeval;
        this.dtDiffEval = dtDiffEval;
        this.ud0 = ud0;
        this.udTime0 = udTime0;
        this.udReevalTime0 = udReevalTime0;
        this.stepMax = stepMax;
        this.sigPeriod = sigPeriod;
        this.sigReplay = sigReplay;
        this.msPeriod = msPeriod;
        this.sigValidity = sigValidity;
        this.msValidity = msValidity;
        this.sigQty = sigQty;
        this.sigStock = sigStock;
        this.xpercent = xpercent;
        this.percentRot = percentRot;
        this.powDelay = powDelay;
        this.avgGenTime = avgGenTime;
        this.medianTimeBlocks = medianTimeBlocks;
        this.httplogs = httplogs;
        this.timeout = timeout;
        this.isolate = isolate;
        this.forksize = forksize;
        this.idtyWindow = idtyWindow;
        this.msWindow = msWindow;
        this.sigWindow = sigWindow;
        this.switchOnHeadAdvance = switchOnHeadAdvance;
        this.pair = pair;
        this.oldPair = oldPair;
        this.salt = salt;
        this.passwd = passwd;
        this.remoteport = remoteport;
        this.remotehost = remotehost;
        this.remoteipv4 = remoteipv4;
        this.remoteipv6 = remoteipv6;
        this.host = host;
        this.port = port;
        this.ipv4 = ipv4;
        this.ipv6 = ipv6;
        this.dos = dos;
        this.upnp = upnp;
        this.homename = homename;
        this.memory = memory;
        this.nobma = nobma;
        this.bmaWithCrawler = bmaWithCrawler;
        this.nonWoTPeersLimit = nonWoTPeersLimit;
        this.proxiesConf = proxiesConf;
        this.ws2p = ws2p;
        this.powNoSecurity = powNoSecurity;
        this.storage = storage;
    }
    static mock() {
        return new ConfDTO("", "", [], [], 0, 3600 * 1000, constants.PROOF_OF_WORK.DEFAULT.CPU, 1, constants.PROOF_OF_WORK.DEFAULT.PREFIX, 0, 0, constants.CONTRACT.DEFAULT.C, constants.CONTRACT.DEFAULT.DT, constants.CONTRACT.DEFAULT.DT_REEVAL, 0, constants.CONTRACT.DEFAULT.UD0, 0, 0, constants.CONTRACT.DEFAULT.STEPMAX, constants.CONTRACT.DEFAULT.SIGPERIOD, constants.CONTRACT.DEFAULT.SIGREPLAY, 0, constants.CONTRACT.DEFAULT.SIGVALIDITY, constants.CONTRACT.DEFAULT.MSVALIDITY, constants.CONTRACT.DEFAULT.SIGQTY, constants.CONTRACT.DEFAULT.SIGSTOCK, constants.CONTRACT.DEFAULT.X_PERCENT, constants.CONTRACT.DEFAULT.PERCENTROT, constants.CONTRACT.DEFAULT.POWDELAY, constants.CONTRACT.DEFAULT.AVGGENTIME, constants.CONTRACT.DEFAULT.MEDIANTIMEBLOCKS, false, 3000, false, constants.BRANCHES.DEFAULT_WINDOW_SIZE, constants.CONTRACT.DEFAULT.IDTYWINDOW, constants.CONTRACT.DEFAULT.MSWINDOW, constants.CONTRACT.DEFAULT.SIGWINDOW, 0, { pub: '', sec: '' }, null, "", "", 0, "", "", "", "", 0, "", "", null, false, "", true, true, false, 100, new proxy_1.ProxiesConf(), undefined);
    }
    static defaultConf() {
        /*return new ConfDTO("", "", [], [], 0, 3600 * 1000, constants.PROOF_OF_WORK.DEFAULT.CPU, 1, constants.PROOF_OF_WORK.DEFAULT.PREFIX, 0, 0, constants.CONTRACT.DEFAULT.C, constants.CONTRACT.DEFAULT.DT, constants.CONTRACT.DEFAULT.DT_REEVAL, 0, constants.CONTRACT.DEFAULT.UD0, 0, 0, constants.CONTRACT.DEFAULT.STEPMAX, constants.CONTRACT.DEFAULT.SIGPERIOD, 0, constants.CONTRACT.DEFAULT.SIGVALIDITY, constants.CONTRACT.DEFAULT.MSVALIDITY, constants.CONTRACT.DEFAULT.SIGQTY, constants.CONTRACT.DEFAULT.SIGSTOCK, constants.CONTRACT.DEFAULT.X_PERCENT, constants.CONTRACT.DEFAULT.PERCENTROT, constants.CONTRACT.DEFAULT.POWDELAY, constants.CONTRACT.DEFAULT.AVGGENTIME, constants.CONTRACT.DEFAULT.MEDIANTIMEBLOCKS, false, 3000, false, constants.BRANCHES.DEFAULT_WINDOW_SIZE, constants.CONTRACT.DEFAULT.IDTYWINDOW, constants.CONTRACT.DEFAULT.MSWINDOW, constants.CONTRACT.DEFAULT.SIGWINDOW, 0, { pub:'', sec:'' }, null, "", "", 0, "", "", "", "", 0, "", "", null, false, "", true, true)*/
        return {
            "currency": null,
            "endpoints": [],
            "rmEndpoints": [],
            "upInterval": 3600 * 1000,
            "c": constants.CONTRACT.DEFAULT.C,
            "dt": constants.CONTRACT.DEFAULT.DT,
            "dtReeval": constants.CONTRACT.DEFAULT.DT_REEVAL,
            "ud0": constants.CONTRACT.DEFAULT.UD0,
            "stepMax": constants.CONTRACT.DEFAULT.STEPMAX,
            "sigPeriod": constants.CONTRACT.DEFAULT.SIGPERIOD,
            "sigReplay": constants.CONTRACT.DEFAULT.SIGREPLAY,
            "sigValidity": constants.CONTRACT.DEFAULT.SIGVALIDITY,
            "msValidity": constants.CONTRACT.DEFAULT.MSVALIDITY,
            "sigQty": constants.CONTRACT.DEFAULT.SIGQTY,
            "xpercent": constants.CONTRACT.DEFAULT.X_PERCENT,
            "percentRot": constants.CONTRACT.DEFAULT.PERCENTROT,
            "powDelay": constants.CONTRACT.DEFAULT.POWDELAY,
            "avgGenTime": constants.CONTRACT.DEFAULT.AVGGENTIME,
            "dtDiffEval": constants.CONTRACT.DEFAULT.DTDIFFEVAL,
            "medianTimeBlocks": constants.CONTRACT.DEFAULT.MEDIANTIMEBLOCKS,
            "httplogs": false,
            "udid2": false,
            "timeout": 3000,
            "isolate": false,
            "forksize": constants.BRANCHES.DEFAULT_WINDOW_SIZE,
            "switchOnHeadAdvance": constants_1.CommonConstants.SWITCH_ON_BRANCH_AHEAD_BY_X_BLOCKS,
            "nonWoTPeersLimit": constants_1.CommonConstants.DEFAULT_NON_WOT_PEERS_LIMIT,
        };
    }
    static complete(conf) {
        return underscore_1.Underscore.extend(ConfDTO.defaultConf(), conf);
    }
}
exports.ConfDTO = ConfDTO;
//# sourceMappingURL=ConfDTO.js.map