import { Cloneable } from "./Cloneable";
export declare class MembershipDTO implements Cloneable {
    version: number;
    currency: string;
    issuer: string;
    type: string;
    blockstamp: string;
    userid: string;
    certts: string;
    signature: string;
    clone(): any;
    sigDate?: number;
    date?: number;
    constructor(version: number, currency: string, issuer: string, type: string, blockstamp: string, userid: string, certts: string, signature: string);
    readonly pubkey: string;
    readonly pub: string;
    readonly membership: string;
    readonly fpr: string;
    readonly number: number;
    readonly block_number: number;
    readonly block_hash: string;
    inline(): string;
    getIdtyHash(): string;
    getRaw(): string;
    getRawSigned(): string;
    json(): {
        signature: string;
        membership: {
            version: number;
            currency: string;
            issuer: string;
            membership: string;
            date: number | undefined;
            sigDate: number | undefined;
            raw: string;
        };
    };
    static fromInline(inlineMS: string, type?: string, currency?: string): MembershipDTO;
    static fromJSONObject(obj: any): MembershipDTO;
    getHash(): string;
}
