/// <reference types="node" />
import * as stream from "stream";
import { PeeringService } from "../../service/PeeringService";
import { FileDAL } from "../dal/fileDAL";
import { DBPeer } from "../db/DBPeer";
export declare class RouterStream extends stream.Transform {
    private peeringService;
    private dal;
    logger: any;
    active: boolean;
    constructor(peeringService: PeeringService, dal: FileDAL);
    setConfDAL(theDAL: FileDAL): void;
    setActive(shouldBeActive: boolean): void;
    _write(obj: any, enc: any, done: any): Promise<void>;
    private route;
    private getRandomInUPPeers;
    private getValidUpPeers;
    /**
    * Get the peer targeted by `to` argument, this node excluded (for not to loop on self).
    */
    private getTargeted;
    static chooseXin(peers: DBPeer[], max: number): DBPeer[];
}
