export declare const BMAConstants: {
    BMA_PORTS_START: number;
    BMA_PORTS_END: number;
    DEFAULT_PORT: number;
    IPV4_REGEXP: RegExp;
    IPV6_REGEXP: RegExp;
    HOST_ONION_REGEX: RegExp;
    PORT_START: number;
    UPNP_INTERVAL: number;
    UPNP_TTL: number;
    PUBLIC_KEY: RegExp;
    SHA256_HASH: RegExp;
    ERRORS: {
        UNKNOWN: {
            httpCode: number;
            uerr: {
                ucode: number;
                message: string;
            };
        };
        UNHANDLED: {
            httpCode: number;
            uerr: {
                ucode: number;
                message: string;
            };
        };
        HTTP_LIMITATION: {
            httpCode: number;
            uerr: {
                ucode: number;
                message: string;
            };
        };
        HTTP_PARAM_PUBKEY_REQUIRED: {
            httpCode: number;
            uerr: {
                ucode: number;
                message: string;
            };
        };
        HTTP_PARAM_IDENTITY_REQUIRED: {
            httpCode: number;
            uerr: {
                ucode: number;
                message: string;
            };
        };
        HTTP_PARAM_PEER_REQUIRED: {
            httpCode: number;
            uerr: {
                ucode: number;
                message: string;
            };
        };
        HTTP_PARAM_BLOCK_REQUIRED: {
            httpCode: number;
            uerr: {
                ucode: number;
                message: string;
            };
        };
        HTTP_PARAM_MEMBERSHIP_REQUIRED: {
            httpCode: number;
            uerr: {
                ucode: number;
                message: string;
            };
        };
        HTTP_PARAM_TX_REQUIRED: {
            httpCode: number;
            uerr: {
                ucode: number;
                message: string;
            };
        };
        HTTP_PARAM_SIG_REQUIRED: {
            httpCode: number;
            uerr: {
                ucode: number;
                message: string;
            };
        };
        HTTP_PARAM_CERT_REQUIRED: {
            httpCode: number;
            uerr: {
                ucode: number;
                message: string;
            };
        };
        HTTP_PARAM_REVOCATION_REQUIRED: {
            httpCode: number;
            uerr: {
                ucode: number;
                message: string;
            };
        };
        HTTP_PARAM_CONF_REQUIRED: {
            httpCode: number;
            uerr: {
                ucode: number;
                message: string;
            };
        };
        HTTP_PARAM_CPU_REQUIRED: {
            httpCode: number;
            uerr: {
                ucode: number;
                message: string;
            };
        };
        NO_MATCHING_IDENTITY: {
            httpCode: number;
            uerr: {
                ucode: number;
                message: string;
            };
        };
        SELF_PEER_NOT_FOUND: {
            httpCode: number;
            uerr: {
                ucode: number;
                message: string;
            };
        };
        NOT_A_MEMBER: {
            httpCode: number;
            uerr: {
                ucode: number;
                message: string;
            };
        };
        NO_CURRENT_BLOCK: {
            httpCode: number;
            uerr: {
                ucode: number;
                message: string;
            };
        };
        PEER_NOT_FOUND: {
            httpCode: number;
            uerr: {
                ucode: number;
                message: string;
            };
        };
        NO_IDTY_MATCHING_PUB_OR_UID: {
            httpCode: number;
            uerr: {
                ucode: number;
                message: string;
            };
        };
        TX_NOT_FOUND: {
            httpCode: number;
            uerr: {
                ucode: number;
                message: string;
            };
        };
        INCORRECT_PAGE_NUMBER: {
            httpCode: number;
            uerr: {
                ucode: number;
                message: string;
            };
        };
    };
};
