// Source file from duniter: Crypto-currency software to manage libre currency such as Ğ1
// Copyright (C) 2018  Cedric Moreau <cem.moreau@gmail.com>
//
// This program is free software: you can redistribute it and/or modify
// it under the terms of the GNU Affero General Public License as published by
// the Free Software Foundation, either version 3 of the License, or
// (at your option) any later version.
//
// This program is distributed in the hope that it will be useful,
// but WITHOUT ANY WARRANTY; without even the implied warranty of
// MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
// GNU Affero General Public License for more details.
"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
const AbstractController_1 = require("./AbstractController");
class NodeBinding extends AbstractController_1.AbstractController {
    constructor() {
        super(...arguments);
        this.summary = () => {
            return {
                "duniter": {
                    "software": "duniter",
                    "version": this.server.version,
                    "forkWindowSize": this.server.conf.forksize
                }
            };
        };
    }
    async sandboxes() {
        return {
            identities: await sandboxIt(this.server.dal.idtyDAL.sandbox),
            memberships: await sandboxIt(this.server.dal.msDAL.sandbox),
            transactions: await sandboxIt(this.server.dal.txsDAL.sandbox)
        };
    }
}
exports.NodeBinding = NodeBinding;
async function sandboxIt(sandbox) {
    return {
        size: sandbox.maxSize,
        free: await sandbox.getSandboxRoom()
    };
}
//# sourceMappingURL=node.js.map