export declare class Limiter {
    private limitPerSecond;
    private limitPerMinute;
    private reqsSec;
    private reqsSecLen;
    private reqsMin;
    private reqsMinLen;
    constructor(strategy: {
        limitPerSecond: number;
        limitPerMinute: number;
    });
    /**
     * Tells wether the quota is reached at current time or not.
     */
    canAnswerNow(): boolean;
    /**
     * Filter the current requests stock to remove the too old ones
     */
    updateRequests(): void;
    processRequest(): void;
}
export declare const BMALimitation: {
    limitAsLowUsage(): Limiter;
    limitAsHighUsage(): Limiter;
    limitAsVeryHighUsage(): Limiter;
    limitAsUnlimited(): Limiter;
    limitAsTest(): Limiter;
    noLimit(): void;
    withLimit(): void;
};
