import { NetworkConfDTO } from "../../../lib/dto/ConfDTO";
import { Server } from "../../../../server";
export interface NetworkInterface {
    ip: string | null;
    port: number | null;
}
export declare const Network: {
    getBestLocalIPv4: typeof getBestLocalIPv4;
    getBestLocalIPv6: typeof getBestLocalIPv6;
    listInterfaces: typeof listInterfaces;
    upnpConf: typeof upnpConf;
    getRandomPort: typeof getRandomPort;
    createServersAndListen: (name: string, server: Server, interfaces: NetworkInterface[], httpLogs: boolean, logger: any, staticPath: string | null, routingCallback: any, listenWebSocket: any, enableFileUpload?: boolean) => Promise<BmaApi>;
};
export declare class BmaApi {
    private name;
    private interfaces;
    private ddosInstance;
    private httpServers;
    private logger;
    private listenings;
    constructor(name: string, interfaces: any, ddosInstance: any, httpServers: any, logger: any);
    getDDOS(): any;
    closeConnections(): Promise<never[]>;
    openConnections(): Promise<never[]>;
}
declare function getBestLocalIPv4(): any;
declare function getBestLocalIPv6(): any;
declare function listInterfaces(): {
    name: string | number | symbol;
    addresses: any;
}[];
declare function upnpConf(noupnp: boolean, logger: any): Promise<NetworkConfDTO>;
declare function getRandomPort(conf: NetworkConfDTO): number;
export {};
