import { ConfDTO } from "../../lib/dto/ConfDTO";
import { Server } from "../../../server";
import { Contacter } from "./lib/contacter";
import { Crawler } from "./lib/crawler";
import { Synchroniser } from "./lib/sync";
import { BlockDTO } from "../../lib/dto/BlockDTO";
export declare const CrawlerDependency: {
    duniter: {
        service: {
            process: (server: Server, conf: ConfDTO, logger: any) => Crawler;
        };
        methods: {
            contacter: (host: string, port: number, opts?: any) => Contacter;
            pullBlocks: (server: Server, pubkey?: string) => Promise<void>;
            pullSandbox: (server: Server) => Promise<void>;
            synchronize: (server: Server, onHost: string, onPort: number, upTo: number, chunkLength: number, allowLocalSync?: boolean) => {
                flow: Synchroniser;
                syncPromise: Promise<void>;
            };
            /**
             * Used by duniter-ui
             * @param {Server} server
             * @param {string} onHost
             * @param {number} onPort
             * @returns {Promise<any>}
             */
            testForSync: (server: Server, onHost: string, onPort: number) => Promise<BlockDTO>;
        };
        cliOptions: {
            value: string;
            desc: string;
        }[];
        cli: ({
            name: string;
            desc: string;
            preventIfRunning: boolean;
            onConfiguredExecute: (server: Server) => Promise<void>;
            onDatabaseExecute: (server: Server, conf: ConfDTO, program: any, params: any) => Promise<any>;
        } | {
            name: string;
            desc: string;
            preventIfRunning: boolean;
            onDatabaseExecute: (server: Server, conf: ConfDTO, program: any, params: any) => Promise<void>;
            onConfiguredExecute?: undefined;
        } | {
            name: string;
            desc: string;
            onDatabaseExecute: (server: Server, conf: ConfDTO, program: any, params: any) => Promise<void>;
            preventIfRunning?: undefined;
            onConfiguredExecute?: undefined;
        })[];
    };
};
