import { HttpMembershipList } from "../../bma/lib/dtos";
export declare class Contacter {
    readonly host: string;
    readonly port: number;
    path: string;
    options: {
        timeout: number;
    };
    fullyQualifiedHost: string;
    constructor(host: string, port: number, opts?: any);
    static fromHostPortPath(host: string, port: number, path: string, opts: {
        timeout?: number;
    }): Contacter;
    getSummary(): Promise<any>;
    getCertifiedBy(search: string): Promise<any>;
    getRequirements(search: string): Promise<any>;
    getRequirementsPending(minsig: number): Promise<any>;
    getLookup(search: string): Promise<any>;
    getBlock(number: number): Promise<any>;
    getCurrent(): Promise<any>;
    getMilestonesPage(): Promise<any>;
    getMilestones(page: number): Promise<any>;
    getPeer(): Promise<any>;
    getPeers(obj?: any): Promise<any>;
    getPeersArray(): Promise<any>;
    getSources(pubkey: string): Promise<any>;
    getBlocks(count: number, fromNumber: number): Promise<any>;
    postPeer(peer: any): Promise<any>;
    postIdentity(raw: string): Promise<any>;
    postCert(cert: string): Promise<any>;
    postRenew(ms: string): Promise<any>;
    postRevocation(rev: string): Promise<any>;
    wotPending(): Promise<HttpMembershipList>;
    wotMembers(): Promise<any>;
    postBlock(rawBlock: string): Promise<any>;
    processTransaction(rawTX: string): Promise<any>;
    private get;
    private post;
    static protocol(port: number): "https://" | "http://";
    static quickly(host: string, port: number, opts: any, callbackPromise: any): Promise<any>;
    static quickly2(peer: any, opts: any, callbackPromise: any): Promise<any>;
    static fetchPeer(host: string, port: number, opts?: any): Promise<any>;
    static fetchBlock(number: number, peer: any, opts?: any): Promise<any>;
    static isReachableFromTheInternet(peer: any, opts: any): Promise<boolean>;
}
