import { BlockDTO } from "../../../../lib/dto/BlockDTO";
import { ISyncDownloader } from "./ISyncDownloader";
import { PeerDTO } from "../../../../lib/dto/PeerDTO";
import { Watcher } from "./Watcher";
import { FileDAL } from "../../../../lib/dal/fileDAL";
export declare abstract class AbstractSynchronizer {
    readonly chunkSize: number;
    constructor(chunkSize: number);
    abstract init(): Promise<void>;
    abstract initWithKnownLocalAndToAndCurrency(to: number, localNumber: number, currency: string): Promise<void>;
    abstract getCurrent(): Promise<BlockDTO | null>;
    abstract getBlock(number: number): Promise<BlockDTO | null>;
    abstract getMilestone(number: number): Promise<BlockDTO | null>;
    abstract p2pDownloader(): ISyncDownloader;
    abstract fsDownloader(): ISyncDownloader;
    abstract syncPeers(fullSync: boolean, to?: number): Promise<void>;
    abstract syncSandbox(): Promise<void>;
    abstract getPeer(): PeerDTO;
    abstract setWatcher(watcher: Watcher): void;
    abstract getCurrency(): string;
    abstract getChunksPath(): string;
    abstract readonly readDAL: FileDAL;
    getChunkRelativePath(i: number): string;
    getChunkName(i: number): string;
}
