import { IRemoteContacter } from "./IRemoteContacter";
import { Contacter } from "../contacter";
import { HttpRequirements } from "../../../bma/lib/dtos";
import { JSONDBPeer } from "../../../../lib/db/DBPeer";
import { BlockDTO } from "../../../../lib/dto/BlockDTO";
export declare class BMARemoteContacter implements IRemoteContacter {
    protected contacter: Contacter;
    type: 'BMA' | 'WS2P';
    constructor(contacter: Contacter);
    getBlock(number: number): Promise<BlockDTO | null>;
    getCurrent(): Promise<BlockDTO | null>;
    getBlocks(count: number, from: number): Promise<BlockDTO[]>;
    getMilestones(page: number): Promise<{
        chunkSize: number;
        totalPages: number;
        currentPage: number;
        milestonesPerPage: number;
        blocks: BlockDTO[];
    }>;
    getMilestonesPage(): Promise<{
        chunkSize: number;
        totalPages: number;
        milestonesPerPage: number;
    }>;
    getPeers(): Promise<(JSONDBPeer | null)[]>;
    getRequirementsPending(minsig: number): Promise<HttpRequirements>;
    getName(): string;
    readonly hostName: string;
}
