"use strict";
// Source file from duniter: Crypto-currency software to manage libre currency such as Ğ1
// Copyright (C) 2018  Cedric Moreau <cem.moreau@gmail.com>
//
// This program is free software: you can redistribute it and/or modify
// it under the terms of the GNU Affero General Public License as published by
// the Free Software Foundation, either version 3 of the License, or
// (at your option) any later version.
//
// This program is distributed in the hope that it will be useful,
// but WITHOUT ANY WARRANTY; without even the implied warranty of
// MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
// GNU Affero General Public License for more details.
Object.defineProperty(exports, "__esModule", { value: true });
const logger_1 = require("../../../../lib/logger");
const logger = logger_1.NewLogger();
class BMARemoteContacter {
    constructor(contacter) {
        this.contacter = contacter;
        this.type = 'BMA';
    }
    getBlock(number) {
        return this.contacter.getBlock(number);
    }
    getCurrent() {
        return this.contacter.getCurrent();
    }
    getBlocks(count, from) {
        return this.contacter.getBlocks(count, from);
    }
    getMilestones(page) {
        return this.contacter.getMilestones(page);
    }
    getMilestonesPage() {
        return this.contacter.getMilestonesPage();
    }
    async getPeers() {
        return (await this.contacter.getPeersArray()).peers;
    }
    getRequirementsPending(minsig) {
        return this.contacter.getRequirementsPending(minsig);
    }
    getName() {
        return "BMA remote '" + this.contacter.fullyQualifiedHost + "'";
    }
    get hostName() {
        return this.contacter.host;
    }
}
exports.BMARemoteContacter = BMARemoteContacter;
//# sourceMappingURL=BMARemoteContacter.js.map