import { JSONDBPeer } from "../../../../lib/db/DBPeer";
import { BlockDTO } from "../../../../lib/dto/BlockDTO";
import { HttpRequirements } from "../../../bma/lib/dtos";
export interface IRemoteContacter {
    getName(): string;
    getPeers(): Promise<(JSONDBPeer | null)[]>;
    getCurrent(): Promise<BlockDTO | null>;
    getBlock(number: number): Promise<BlockDTO | null>;
    getMilestonesPage(): Promise<{
        chunkSize: number;
        totalPages: number;
        milestonesPerPage: number;
    }>;
    getMilestones(page: number): Promise<{
        chunkSize: number;
        totalPages: number;
        currentPage: number;
        milestonesPerPage: number;
        blocks: BlockDTO[];
    }>;
    getBlocks(count: number, from: number): Promise<BlockDTO[]>;
    getRequirementsPending(number: number): Promise<HttpRequirements>;
    hostName: string;
    type: 'BMA' | 'WS2P';
}
