import { ISyncDownloader } from "./ISyncDownloader";
import { BlockDTO } from "../../../../lib/dto/BlockDTO";
import { PeerDTO } from "../../../../lib/dto/PeerDTO";
import { Watcher } from "./Watcher";
import { PeeringService } from "../../../../service/PeeringService";
import { Server } from "../../../../../server";
import { FileDAL } from "../../../../lib/dal/fileDAL";
import { AbstractSynchronizer } from "./AbstractSynchronizer";
export declare class LocalPathSynchronizer extends AbstractSynchronizer {
    private path;
    private server;
    private theP2pDownloader;
    private theFsDownloader;
    private currency;
    private watcher;
    private ls;
    constructor(path: string, server: Server, chunkSize: number);
    readonly dal: FileDAL;
    readonly readDAL: FileDAL;
    readonly PeeringService: PeeringService;
    getCurrency(): string;
    getPeer(): PeerDTO;
    getChunksPath(): string;
    setWatcher(watcher: Watcher): void;
    init(): Promise<void>;
    initWithKnownLocalAndToAndCurrency(to: number, localNumber: number, currency: string): Promise<void>;
    p2pDownloader(): ISyncDownloader;
    fsDownloader(): ISyncDownloader;
    getCurrent(): Promise<BlockDTO | null>;
    getBlock(number: number): Promise<BlockDTO | null>;
    getMilestone(number: number): Promise<BlockDTO | null>;
    syncPeers(fullSync: boolean, to?: number): Promise<void>;
    syncSandbox(): Promise<void>;
}
