import { ISyncDownloader } from "./ISyncDownloader";
import { BlockDTO } from "../../../../lib/dto/BlockDTO";
import { PeerDTO } from "../../../../lib/dto/PeerDTO";
import { Watcher } from "./Watcher";
import { PeeringService } from "../../../../service/PeeringService";
import { Server } from "../../../../../server";
import { FileDAL } from "../../../../lib/dal/fileDAL";
import { AbstractSynchronizer } from "./AbstractSynchronizer";
import { IRemoteContacter } from "./IRemoteContacter";
import { Keypair } from "../../../../lib/dto/ConfDTO";
export declare class RemoteSynchronizer extends AbstractSynchronizer {
    private host;
    private port;
    private server;
    private noShufflePeers;
    private otherDAL?;
    private allowLocalSync;
    private currency;
    private node;
    private peer;
    private shuffledPeers;
    private theP2pDownloader;
    private theFsDownloader;
    private to;
    private localNumber;
    private watcher;
    private endpoint;
    private hasMilestonesPages;
    private milestones;
    private milestonesPerPage;
    private maxPage;
    constructor(host: string, port: number, server: Server, chunkSize: number, noShufflePeers?: boolean, otherDAL?: FileDAL | undefined, allowLocalSync?: boolean);
    readonly dal: FileDAL;
    readonly readDAL: FileDAL;
    readonly PeeringService: PeeringService;
    getCurrency(): string;
    getPeer(): PeerDTO;
    setWatcher(watcher: Watcher): void;
    getChunksPath(): string;
    init(): Promise<void>;
    static getSyncAPI(hosts: {
        isBMA?: boolean;
        isWS2P?: boolean;
        host: string;
        port: number;
        path?: string;
    }[], keypair: Keypair): Promise<{
        api: IRemoteContacter;
        peering: any;
        endpoint: string;
        currency: any;
    }>;
    initWithKnownLocalAndToAndCurrency(to: number, localNumber: number): Promise<void>;
    p2pDownloader(): ISyncDownloader;
    fsDownloader(): ISyncDownloader;
    getCurrent(): Promise<BlockDTO | null>;
    getBlock(number: number): Promise<BlockDTO | null>;
    getMilestone(number: number): Promise<BlockDTO | null>;
    static test(host: string, port: number, keypair: Keypair): Promise<BlockDTO>;
    syncPeers(fullSync: boolean, to?: number): Promise<void>;
    syncSandbox(): Promise<void>;
}
