import { IRemoteContacter } from "./IRemoteContacter";
import { WS2PRequester } from "../../../ws2p/lib/WS2PRequester";
import { JSONDBPeer } from "../../../../lib/db/DBPeer";
import { BlockDTO } from "../../../../lib/dto/BlockDTO";
import { HttpRequirements } from "../../../bma/lib/dtos";
export declare class WS2PRemoteContacter implements IRemoteContacter {
    protected requester: WS2PRequester;
    type: 'BMA' | 'WS2P';
    getRequirementsPending(min: number): Promise<HttpRequirements>;
    constructor(requester: WS2PRequester);
    getBlock(number: number): Promise<BlockDTO | null>;
    getMilestones(page: number): Promise<{
        chunkSize: number;
        totalPages: number;
        currentPage: number;
        milestonesPerPage: number;
        blocks: BlockDTO[];
    }>;
    getMilestonesPage(): Promise<{
        chunkSize: number;
        totalPages: number;
        milestonesPerPage: number;
    }>;
    getCurrent(): Promise<BlockDTO | null>;
    getBlocks(count: number, from: number): Promise<BlockDTO[]>;
    getPeers(): Promise<(JSONDBPeer | null)[]>;
    getName(): string;
    readonly hostName: string;
}
