"use strict";
// Source file from duniter: Crypto-currency software to manage libre currency such as Ğ1
// Copyright (C) 2018  Cedric Moreau <cem.moreau@gmail.com>
//
// This program is free software: you can redistribute it and/or modify
// it under the terms of the GNU Affero General Public License as published by
// the Free Software Foundation, either version 3 of the License, or
// (at your option) any later version.
//
// This program is distributed in the hope that it will be useful,
// but WITHOUT ANY WARRANTY; without even the implied warranty of
// MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
// GNU Affero General Public License for more details.
Object.defineProperty(exports, "__esModule", { value: true });
const logger_1 = require("../../../../lib/logger");
const DBPeer_1 = require("../../../../lib/db/DBPeer");
const PeerDTO_1 = require("../../../../lib/dto/PeerDTO");
const logger = logger_1.NewLogger();
class WS2PRemoteContacter {
    constructor(requester) {
        this.requester = requester;
        this.type = 'WS2P';
    }
    getRequirementsPending(min) {
        return this.requester.getRequirementsPending(min);
    }
    getBlock(number) {
        return this.requester.getBlock(number);
    }
    getMilestones(page) {
        return this.requester.getMilestones(page);
    }
    getMilestonesPage() {
        return this.requester.getMilestonesPage();
    }
    getCurrent() {
        return this.requester.getCurrent();
    }
    getBlocks(count, from) {
        return this.requester.getBlocks(count, from);
    }
    async getPeers() {
        return (await this.requester.getPeers()).map(p => DBPeer_1.DBPeer.fromPeerDTO(PeerDTO_1.PeerDTO.fromJSONObject(p)));
    }
    getName() {
        return "WS2P remote";
    }
    get hostName() {
        return this.requester.hostName;
    }
}
exports.WS2PRemoteContacter = WS2PRemoteContacter;
//# sourceMappingURL=WS2PRemoteContacter.js.map