import { PeerDTO } from "../../../../../lib/dto/PeerDTO";
import { Keypair } from "../../../../../lib/dto/ConfDTO";
import { BlockDTO } from "../../../../../lib/dto/BlockDTO";
export declare class P2pCandidate {
    p: PeerDTO;
    private keypair;
    private logger;
    private allowLocalSync;
    private readonly apiPromise;
    private dlPromise;
    private readonly responseTimes;
    private api;
    private nbSuccess;
    private isExcluded;
    private failures;
    private reserved;
    constructor(p: PeerDTO, keypair: Keypair, logger: any, allowLocalSync: boolean);
    addFailure(): void;
    isReady(): boolean | null | undefined;
    waitAvailability(maxWait: number): Promise<boolean>;
    hasAvailableApi(): boolean;
    avgResponseTime(): number;
    readonly hostName: string;
    downloadBlocks(count: number, from: number): Promise<BlockDTO[] | null>;
    private getRemoteAPIs;
    private initAPI;
    reserve(): void;
    readonly apiName: "BMA" | "WS2P" | null | undefined;
}
