"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
const BlockDTO_1 = require("../../../lib/dto/BlockDTO");
async function dumpForks(server, blocks) {
    return dumpBlocks(server, blocks, false);
}
exports.dumpForks = dumpForks;
async function dumpBlocks(server, blocks, showMainBcOnly = true) {
    const patterns = blocks.split(',');
    for (const p of patterns) {
        // Single block to dump
        if (p.match(/^\d+$/)) {
            const bNumber = parseInt(p);
            if (showMainBcOnly) {
                dumpBlockIfDefined(await server.dal.getBlock(bNumber));
            }
            else {
                (await server.dal.getPotentialForkBlocks(bNumber, 0, bNumber)).forEach(dumpBlockIfDefined);
            }
        }
    }
}
exports.dumpBlocks = dumpBlocks;
function dumpBlockIfDefined(b) {
    console.log(BlockDTO_1.BlockDTO.fromJSONObject(b).getRawSigned());
}
exports.dumpBlockIfDefined = dumpBlockIfDefined;
//# sourceMappingURL=dump.blocks.js.map