import { ConfDTO } from "../../lib/dto/ConfDTO";
import { BlockGeneratorWhichProves } from "./lib/blockGenerator";
import { Prover } from "./lib/prover";
import { Server } from "../../../server";
import { BlockDTO } from "../../lib/dto/BlockDTO";
export declare const ProverDependency: {
    duniter: {
        /*********** Permanent prover **************/
        config: {
            onLoading: (conf: ConfDTO) => Promise<void>;
            beforeSave: (conf: ConfDTO) => Promise<void>;
        };
        service: {
            output: (server: Server) => Prover;
        };
        methods: {
            hookServer: (server: Server) => void;
            prover: (server: Server) => Prover;
            blockGenerator: (server: Server, prover: any) => BlockGeneratorWhichProves;
            generateTheNextBlock: (server: Server, manualValues: any) => Promise<BlockDTO>;
            generateAndProveTheNext: (server: Server, block: any, trial: any, manualValues: any) => Promise<any>;
        };
        /*********** CLI gen-next + gen-root **************/
        cliOptions: ({
            value: string;
            desc: string;
            parser?: undefined;
        } | {
            value: string;
            desc: string;
            parser: typeof parseInt;
        })[];
        cli: ({
            name: string;
            desc: string;
            onDatabaseExecute: (server: Server, conf: ConfDTO, program: any, params: any) => Promise<{}>;
            preventIfRunning?: undefined;
        } | {
            name: string;
            desc: string;
            onDatabaseExecute: () => Promise<void>;
            preventIfRunning?: undefined;
        } | {
            name: string;
            desc: string;
            preventIfRunning: boolean;
            onDatabaseExecute: (server: Server, conf: ConfDTO, program: any, params: any) => Promise<void>;
        } | {
            name: string;
            desc: string;
            preventIfRunning: boolean;
            onDatabaseExecute: (server: Server, conf: ConfDTO, program: any, params: any) => Promise<{}>;
        })[];
    };
};
