import { ConfDTO } from "../../../lib/dto/ConfDTO";
import { PowWorker } from "./PowWorker";
import { FileDAL } from "../../../lib/dal/fileDAL";
import { ProofAsk } from "./blockProver";
export interface SlaveWorker {
    worker: PowWorker;
    index: number;
    online: Promise<void>;
    nonceBeginning: number;
}
/**
 * Cluster controller, handles the messages between the main program and the PoW cluster.
 */
export declare class Master {
    private nbCores;
    private dal?;
    nbCancels: number;
    clusterId: number;
    currentPromise: any | null;
    slaves: SlaveWorker[];
    slavesMap: {
        [k: number]: SlaveWorker | null;
    };
    conf: any;
    logger: any;
    onInfoCallback: any;
    workersOnline: Promise<any>[];
    constructor(nbCores: number | null | undefined, logger: any, dal?: FileDAL | undefined);
    readonly nbWorkers: number;
    onInfoMessage: any;
    onWorkerMessage(workerIndex: number, message: any): void;
    /*****************
     * CLUSTER METHODS
     ****************/
    initCluster(): Promise<any[]>;
    changeConf(conf: ConfDTO): Promise<ConfDTO>;
    private cancelWorkersWork;
    cancelWork(): Promise<any>;
    shutDownWorkers(): Promise<void>;
    proveByWorkers(stuff: ProofAsk): Promise<any>;
    static defaultLogger(): {
        info: (message: any) => void;
    };
}
