// Source file from duniter: Crypto-currency software to manage libre currency such as Ğ1
// Copyright (C) 2018  Cedric Moreau <cem.moreau@gmail.com>
//
// This program is free software: you can redistribute it and/or modify
// it under the terms of the GNU Affero General Public License as published by
// the Free Software Foundation, either version 3 of the License, or
// (at your option) any later version.
//
// This program is distributed in the hope that it will be useful,
// but WITHOUT ANY WARRANTY; without even the implied warranty of
// MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
// GNU Affero General Public License for more details.
"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
const permanentProver_1 = require("./permanentProver");
const stream = require("stream");
const other_constants_1 = require("../../../lib/other_constants");
class Prover extends stream.Transform {
    constructor(server) {
        super({ objectMode: true });
        this.permaProver = new permanentProver_1.PermanentProver(server);
    }
    _write(obj, enc, done) {
        // Never close the stream
        if (obj) {
            if (obj.bcEvent && obj.bcEvent === other_constants_1.OtherConstants.BC_EVENT.HEAD_CHANGED || obj.bcEvent === other_constants_1.OtherConstants.BC_EVENT.SWITCHED) {
                this.permaProver.blockchainChanged(obj.block);
            }
            else if (obj.cpu !== undefined) {
                this.permaProver.prover.changeCPU(obj.cpu); // We multiply by 10 to give room to computers with < 100 cores
            }
        }
        done && done();
    }
    ;
    async startService() {
        this.permaProver.allowedToStart();
    }
    async stopService() {
        await this.permaProver.stopEveryting();
    }
}
exports.Prover = Prover;
//# sourceMappingURL=prover.js.map