/// <reference types="node" />
import { ConfDTO } from "../lib/dto/ConfDTO";
import { Server } from "../../server";
import * as stream from "stream";
import { Multicaster } from "../lib/streams/multicaster";
export declare const RouterDependency: {
    duniter: {
        service: {
            output: (server: Server, conf: ConfDTO, logger: any) => Router;
        };
        methods: {
            routeToNetwork: (server: Server) => void;
        };
    };
};
/**
 * Service which triggers the server's peering generation (actualization of the Peer document).
 * @constructor
 */
export declare class Router extends stream.Transform {
    private server;
    theRouter: any;
    theMulticaster: Multicaster;
    constructor(server: Server);
    _write(obj: any, enc: string, done: any): void;
    startService(): Promise<void>;
    stopService(): Promise<void>;
}
