/// <reference types="node" />
import { ConfDTO, WS2PConfDTO } from "../../lib/dto/ConfDTO";
import { Server } from "../../../server";
import * as stream from 'stream';
import { WS2PCluster } from "./lib/WS2PCluster";
export declare const WS2PDependency: {
    duniter: {
        cliOptions: ({
            value: string;
            desc: string;
            parser?: undefined;
        } | {
            value: string;
            desc: string;
            parser: (val: string) => number;
        })[];
        config: {
            onLoading: (conf: WS2PConfDTO, program: any, logger: any) => Promise<void>;
            beforeSave: (conf: WS2PConfDTO) => Promise<void>;
        };
        methods: {
            bindWS2P: (server: Server) => WS2PAPI;
        };
        service: {
            input: (server: Server) => WS2PAPI;
        };
        cli: {
            name: string;
            desc: string;
            logs: boolean;
            onConfiguredExecute: (server: Server, conf: ConfDTO, program: any, params: any) => Promise<void>;
        }[];
    };
};
export declare class WS2PAPI extends stream.Transform {
    private server;
    private conf;
    private cluster;
    private upnpAPI;
    constructor(server: Server, conf: ConfDTO);
    getCluster(): WS2PCluster;
    startService: () => Promise<void>;
    stopService: () => Promise<void>;
    getEndpoint(): Promise<string>;
}
