"use strict";
// Source file from duniter: Crypto-currency software to manage libre currency such as Ğ1
// Copyright (C) 2018  Cedric Moreau <cem.moreau@gmail.com>
//
// This program is free software: you can redistribute it and/or modify
// it under the terms of the GNU Affero General Public License as published by
// the Free Software Foundation, either version 3 of the License, or
// (at your option) any later version.
//
// This program is distributed in the hope that it will be useful,
// but WITHOUT ANY WARRANTY; without even the implied warranty of
// MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
// GNU Affero General Public License for more details.
Object.defineProperty(exports, "__esModule", { value: true });
const WS2PRequester_1 = require("./WS2PRequester");
const sandbox_1 = require("../../crawler/lib/sandbox");
class WS2PDocpoolPuller {
    constructor(server, connection) {
        this.server = server;
        this.connection = connection;
    }
    async pull() {
        const requester = WS2PRequester_1.WS2PRequester.fromConnection(this.connection);
        // node.pubkey = p.pubkey;
        return sandbox_1.pullSandboxToLocalServer(this.server.conf.currency, {
            type: 'WS2P',
            getRequirementsPending: (minCert = 1) => {
                return requester.getRequirementsPending(minCert);
            },
            getName: () => this.connection.pubkey,
            getPeers: async () => [],
            getCurrent: async () => null,
            getBlock: async () => null,
            getBlocks: async () => [],
            getMilestonesPage: async () => ({ chunkSize: 0, totalPages: 0, milestonesPerPage: 0 }),
            getMilestones: async () => ({ chunkSize: 0, totalPages: 0, currentPage: 0, milestonesPerPage: 0, blocks: [] }),
            hostName: ''
        }, this.server, this.server.logger);
    }
}
exports.WS2PDocpoolPuller = WS2PDocpoolPuller;
//# sourceMappingURL=WS2PDocpoolPuller.js.map