import { WS2PConnection } from "./WS2PConnection";
import { BlockDTO } from "../../../lib/dto/BlockDTO";
import { PeerDTO } from "../../../lib/dto/PeerDTO";
import { HttpMilestonePage } from "../../bma/lib/dtos";
export declare enum WS2P_REQ {
    KNOWN_PEERS = 0,
    PEER_DOCUMENT = 1,
    WOT_REQUIREMENTS_OF_PENDING = 2,
    BLOCKS_CHUNK = 3,
    BLOCK_BY_NUMBER = 4,
    CURRENT = 5,
    MILESTONES_PAGE = 6,
    MILESTONES = 7
}
export declare class WS2PRequester {
    protected ws2pc: WS2PConnection;
    private constructor();
    static fromConnection(ws2pc: WS2PConnection): WS2PRequester;
    getPeer(): Promise<PeerDTO>;
    getPeers(): Promise<PeerDTO[]>;
    getCurrent(): Promise<BlockDTO>;
    getMilestonesPage(): Promise<HttpMilestonePage>;
    getMilestones(page: number): Promise<HttpMilestonePage>;
    getBlock(number: number): Promise<BlockDTO>;
    getBlocks(count: number, fromNumber: number): Promise<BlockDTO[]>;
    getPubkey(): string;
    getRequirementsPending(minCert?: number): Promise<any>;
    private query;
    readonly hostName: string;
}
