export declare class GlobalFifoPromise {
    private fifo;
    private operations;
    private currentPromise;
    constructor();
    /**
     * Adds a promise to a FIFO stack of promises, so the given promise will be executed against a shared FIFO stack.
     * @param operationId The ID of the operation, which indicates which task to reject if the FIFO already contains it
     * @param p
     */
    pushFIFOPromise<T>(operationId: string, p: () => Promise<T>): Promise<T>;
    closeFIFO(): Promise<void>;
    remainingTasksCount(): any;
}
