import { GlobalFifoPromise } from "./GlobalFifoPromise";
import { FileDAL } from "../lib/dal/fileDAL";
import { ConfDTO } from "../lib/dto/ConfDTO";
import { DBIdentity } from "../lib/dal/sqliteDAL/IdentityDAL";
import { RevocationDTO } from "../lib/dto/RevocationDTO";
import { BasicIdentity } from "../lib/dto/IdentityDTO";
import { CertificationDTO } from "../lib/dto/CertificationDTO";
import { FIFOService } from "./FIFOService";
export declare class IdentityService extends FIFOService {
    dal: FileDAL;
    conf: ConfDTO;
    logger: any;
    constructor(fifoPromiseHandler: GlobalFifoPromise);
    setConfDAL(newConf: ConfDTO, newDAL: FileDAL): void;
    searchIdentities(search: string): Promise<DBIdentity[]>;
    findMember(search: string): Promise<{
        idty: {
            pubkey: string;
            uid: string;
            buid: string;
        };
        memberships: {
            blockstamp: string;
            membership: string;
            number: number;
            fpr: string;
            written_number: number | null;
        }[];
    }>;
    getPendingFromPubkey(pubkey: string): Promise<DBIdentity[]>;
    submitIdentity(idty: BasicIdentity, byAbsorption?: boolean): Promise<DBIdentity>;
    submitCertification(obj: any): Promise<CertificationDTO>;
    submitRevocation(obj: any): Promise<RevocationDTO>;
}
