import { ConfDTO } from "../lib/dto/ConfDTO";
import { FileDAL } from "../lib/dal/fileDAL";
import { PeerDTO } from "../lib/dto/PeerDTO";
import { Server } from "../../server";
import { GlobalFifoPromise } from "./GlobalFifoPromise";
import { DBPeer } from "../lib/db/DBPeer";
export interface Keyring {
    publicKey: string;
    secretKey: string;
}
export declare class PeeringService {
    private server;
    private fifoPromiseHandler;
    conf: ConfDTO;
    dal: FileDAL;
    selfPubkey: string;
    pair: Keyring;
    pubkey: string;
    peerInstance: DBPeer | null;
    logger: any;
    constructor(server: Server, fifoPromiseHandler: GlobalFifoPromise);
    setConfDAL(newConf: ConfDTO, newDAL: FileDAL, newPair: Keyring): void;
    peer(newPeer?: DBPeer | null): Promise<PeerDTO>;
    mirrorBMAEndpoints(): Promise<string[]>;
    checkPeerSignature(p: PeerDTO): boolean;
    submitP(peering: DBPeer, eraseIfAlreadyRecorded?: boolean, cautious?: boolean, acceptNonWoT?: boolean): Promise<PeerDTO>;
    handleNewerPeer(pretendedNewer: DBPeer): Promise<PeerDTO>;
    generateSelfPeer(theConf: {
        currency: string;
    }, signalTimeInterval?: number): Promise<DBPeer | null>;
    private getOtherEndpoints;
}
