"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
const toolbox_1 = require("./toolbox");
const assert = require("assert");
const underscore_1 = require("../../../app/lib/common-libs/underscore");
function writeBasicTestWith2Users(writeTests) {
    writeBasicTestWithConfAnd2Users({}, writeTests);
}
exports.writeBasicTestWith2Users = writeBasicTestWith2Users;
function writeBasicTestWithConfAnd2Users(conf, writeTests) {
    let s1, cat, tac, toc, tic;
    const configuration = underscore_1.Underscore.extend({
        medianTimeBlocks: 1,
        pair: {
            pub: 'HgTTJLAQ5sqfknMq7yLPZbehtuLSsKj9CxWN7k8QvYJd',
            sec: '51w4fEShBk1jCMauWu4mLpmDVfHksKmWcygpxriqCEZizbtERA6de4STKRkQBpxmMUwsKXRjSzuQ8ECwmqN1u2DP'
        }
    }, conf);
    before(async () => {
        s1 = toolbox_1.NewTestingServer(configuration);
        cat = toolbox_1.catUser(s1);
        tac = toolbox_1.tacUser(s1);
        toc = toolbox_1.tocUser(s1);
        tic = toolbox_1.ticUser(s1);
        await s1.prepareForNetwork();
    });
    writeTests((title, cb) => {
        it(title, async () => {
            await cb(s1, cat, tac, toc, tic);
        });
    });
}
exports.writeBasicTestWithConfAnd2Users = writeBasicTestWithConfAnd2Users;
async function createCurrencyWith2Blocks(s, cat, tac) {
    await cat.createIdentity();
    await tac.createIdentity();
    await cat.cert(tac);
    await tac.cert(cat);
    await cat.join();
    await tac.join();
    await s.commit();
    await s.commit();
    await s.commit();
}
exports.createCurrencyWith2Blocks = createCurrencyWith2Blocks;
function assertEqual(value, expected) {
    assert.equal(value, expected);
}
exports.assertEqual = assertEqual;
function assertTrue(expected) {
    assert.equal(true, expected);
}
exports.assertTrue = assertTrue;
function assertNotNull(value) {
    assert.notEqual(value, null);
}
exports.assertNotNull = assertNotNull;
function assertNull(value) {
    assert.equal(value, null);
}
exports.assertNull = assertNull;
function assertFalse(expected) {
    assert.equal(false, expected);
}
exports.assertFalse = assertFalse;
//# sourceMappingURL=test-framework.js.map