"use strict";
// Source file from duniter: Crypto-currency software to manage libre currency such as Ğ1
// Copyright (C) 2018  Cedric Moreau <cem.moreau@gmail.com>
//
// This program is free software: you can redistribute it and/or modify
// it under the terms of the GNU Affero General Public License as published by
// the Free Software Foundation, either version 3 of the License, or
// (at your option) any later version.
//
// This program is distributed in the hope that it will be useful,
// but WITHOUT ANY WARRANTY; without even the implied warranty of
// MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
// GNU Affero General Public License for more details.
Object.defineProperty(exports, "__esModule", { value: true });
const assert = require("assert");
const should = require('should');
async function shouldThrow(promise) {
    let error = false;
    try {
        await promise;
    }
    catch (e) {
        error = true;
    }
    promise.should.be.rejected()(error).should.equal(true);
}
exports.shouldThrow = shouldThrow;
async function shouldNotFail(promise) {
    try {
        await promise;
    }
    catch (e) {
        let err = e;
        if (typeof e === 'string') {
            err = JSON.parse(e.message);
        }
        should.not.exist(err);
    }
}
exports.shouldNotFail = shouldNotFail;
exports.shouldFail = async (promise, message = null) => {
    try {
        await promise;
        throw '{ "message": "Should have thrown an error" }';
    }
    catch (e) {
        let err = e;
        if (typeof e === "string") {
            err = JSON.parse(e);
        }
        err.should.have.property('message').equal(message);
    }
};
exports.assertThrows = async (promise, message = null) => {
    try {
        await promise;
        throw "Should have thrown";
    }
    catch (e) {
        if (e === "Should have thrown") {
            throw e;
        }
        assert.equal(e, message);
    }
};
exports.assertThrowsSync = (f) => {
    try {
        f();
        throw "Should have thrown";
    }
    catch (e) {
        if (e === "Should have thrown") {
            throw e;
        }
    }
};
//# sourceMappingURL=unit-tools.js.map